#include"bingo.h"

/*--------------------------------------------*/

FONCTION int TestArbre()
/* vrifie l'existence d'un arbre, cad presence au moins d'un brevet */
debut

  SI L_NBBREVETS()!=0 ALORS
     retour VRAI;
  FIN_SI

  Message(13,ATTRTITLE,NON_INIT,"\n   AUCUN BREVET REUSSI POUR L'INSTANT => PAS D'ARBRE !");
  retour FAUX;
fin

/*--------------------------------------------*/
FONCTION int BrevetEstDansPT(int idBrevet)
debut
  int i;

  i=0;
  TANTQUE i<NB_MAX_ITEM_PT*NB_MAX_ELEVES FAIRE
     SI PT[i]==idBrevet ALORS
	retour VRAI;
     FIN_SI
     i++;
  FIN_TANTQUE

  retour FAUX;
fin

/*--------------------------------------------*/

PROCEDURE AffichArbre(int eleve, int arbreClasse)
debut
  int i,k1,k2,x;
  int idBrevet; /* indice du brevet */
  int delta;
  int dxDepartBranche=0,dxBranche=0, dyDepartBranche=0,dyBranche=0;
  int dxTronc, dyTronc, premiereBranche=999;
  int gauche=VRAI;
/*  int nbBranches=0;*/
  int hauteurTronc;

  int largeurTronc;
  int nbBrevetsTraites;
/*  int nbBranchesMax;*/

  int couleur, memoCouleur=COULEUR7;

  /* initialisation */
  i=0;
  TANTQUE i<=L_NBBREVETS() FAIRE
     brevDejaAff[i]=FAUX;
     valBrevet[i]=0;
     i++;
  FIN_TANTQUE
  largeurTronc=LargeurTronc;
  nbBrevetsTraites=L_NBBREVETSDANSARBRE();

  brevetsClasses[0]=NON_INIT;
  ClasseParNbDetenteurs(brevetsClasses);

/*  SI L_ORDRE()!=ORDRE_CHRONO ALORS
  ClasseParOrdreAcquisition(brevetsClasses);
   FIN_SI*/

  /* Si c'est l'arbre de l'enfant, */
  /* on ne traite que les brevets obtenus par l'enfant */
  /* en les classant dans l'ordre chronologique inverse */
/*  SI eleve>=0 ET arbreClasse==FAUX ALORS
     nbBrevetsTraites=L_NBBREVETSELEV(eleve);
     i=1;
     TANTQUE i<=L_NBBREVETSELEV(eleve) FAIRE
	brevetsClasses[i]=L_BREVELEV(eleve,L_NBBREVETSELEV(eleve)-i+1);
	i++;
    FIN_TANTQUE
     largeurTronc=max(2,L_NBBREVETSELEV(eleve)/8);
  FIN_SI   */

  /* si c'est l'arbuste de l'enfant, on ne conserve que les brevets qu'il a */
  SI eleve>=0 ET arbreClasse==FAUX ALORS
     i=1;
     TANTQUE i<=L_NBBREVETS() FAIRE
	SI EnfantABrevet(eleve,brevetsClasses[i])==FAUX ALORS
	   brevDejaAff[brevetsClasses[i]]=VRAI;
	FIN_SI
	i++;
     FIN_TANTQUE
  FIN_SI

  i=1;dxTronc=X_AXETRONC-1;dyTronc=Y_AXETRONC;
  gauche=VRAI;
  hauteurTronc=largeurTronc;
/*  nbBranchesMax=2*(nbBrevetsTraites-largeurTronc*hauteurTronc)/(3*largeurTronc);*/
/*  dyDepartBranche=dyTronc+1-hauteurTronc;*/
  dyDepartBranche=dyTronc;

  /* traitement de la succession des branches et du tronc */
/*  nbBranches=0;*/

  TANTQUE i<=nbBrevetsTraites FAIRE
    idBrevet=brevetsClasses[i];

    SI brevDejaAff[idBrevet]==FAUX ALORS
       SI (eleve>=0 ET arbreClasse==FAUX ET
	  L_BREVELEV(eleve,L_NBBREVETSELEV(eleve))==idBrevet)
	  OU
	  ((eleve<0 OU arbreClasse!=FAUX) ET
	   DernierBrevetEnfant(idBrevet)==VRAI) ALORS

/*	  nbBranches++;*/
	  SI premiereBranche==999 ALORS
	     premiereBranche=dyDepartBranche;
	  FIN_SI

	  /* on change de ct */
	  SI gauche==VRAI ALORS
	     gauche=FAUX;
	     dyDepartBranche=dyDepartBranche-1;
	     delta=-1;
	     dxDepartBranche=X_AXETRONC+delta;
	  SINON
	     gauche=VRAI;
	     dxDepartBranche=X_AXETRONC+largeurTronc;
	     delta=1;
	  FIN_SI

	  couleur=COULEUR6;
	  AffichBrevet(dxDepartBranche,dyDepartBranche,eleve,idBrevet,FAUX,couleur);
	  brevDejaAff[idBrevet]=VRAI;

	  k1=i;
	  k2=k1+1;
	  x=0;
	  dyBranche=dyDepartBranche;
	  dxBranche=dxDepartBranche;
	  TANTQUE k2<=nbBrevetsTraites FAIRE
/*	     ET L_NBDETENTEURS(brevetsClasses[k2])>=L_NBDETENTEURS(brevetsClasses[i])-(L_NBELEVES()/4) FAIRE*/

	     SI brevDejaAff[brevetsClasses[k2]]==FAUX ET
		Ressemblance(brevetsClasses[k2],brevetsClasses[k1])==100 ALORS
		dxBranche=dxBranche+delta;
		idBrevet=brevetsClasses[k2];

		SI L_NBDETENTEURS(brevetsClasses[k2])==1 ALORS
		   couleur=COULEUR9;
		SINON
		   couleur=COULEUR10;
		FIN_SI

		AffichBrevet(dxBranche,dyBranche,eleve,idBrevet,FAUX,couleur);
		brevDejaAff[idBrevet]=VRAI;
		k1=k2;
		x++;
	     FIN_SI
	     k2++;
	  FIN_TANTQUE

	SINON
	  x=0;
	  /* on affiche dans le tronc */
	  /* i est le dernier indice du tronc, on rcupre le dernier indice du tronc */
	  SI brevDejaAff[brevetsClasses[i]]==FAUX ALORS
	     idBrevet=brevetsClasses[i];
	     brevDejaAff[idBrevet]=VRAI;
	     dxTronc=dxTronc++;
	     SI dxTronc>=X_AXETRONC+largeurTronc ALORS
		dxTronc=X_AXETRONC;dyTronc=dyTronc-1;
		SI dyTronc<dyDepartBranche ALORS
		   dyDepartBranche=dyDepartBranche-1;
		FIN_SI
/*		SI (dyTronc>Y_AXETRONC-hauteurTronc) OU*/
		SI (dyTronc>Y_AXETRONC-hauteurTronc ET premiereBranche==999)
		   OU
		   (premiereBranche!=999 ET dyTronc>premiereBranche) ALORS
		   couleur = COULEUR7;
		SINON
		   couleur=COULEUR10;
		FIN_SI
	     SINON
		couleur=memoCouleur;
	     FIN_SI

	     memoCouleur=couleur;

/*	     SI eleve>=0 ET arbreClasse!=FAUX ALORS*/
/*		couleur = CouleurBrevet(couleur, idBrevet,eleve,FAUX);*/
/*	     FIN_SI                                  */

	     AffichBrevet(dxTronc,dyTronc,eleve,idBrevet,FAUX,couleur);
	  FIN_SI
	FIN_SI
     FIN_SI
     i++;
  FIN_TANTQUE



  /* Affichage des brevets avec aucun dtenteur dans une colonne  part */
  _wingotoxy(60,22);_winputs("Nouveaux projets");
  SI L_MODECAT()==MODE_SANS_CATEGORIE ALORS
     idBrevet=1;
     dxBranche=0;dyBranche=0;
     TANTQUE idBrevet<=L_NBBREVETS() FAIRE
       SI (L_NBDETENTEURS(idBrevet)==0) OU
	  (eleve>=0 ET arbreClasse==FAUX ET (EnfantABrevet(eleve,idBrevet)!=1))  ALORS
	  AffichBrevet(60+dxBranche,19-dyBranche,eleve,idBrevet,FAUX,couleur);
	  dxBranche++;
	  SI dxBranche>=15 ALORS
	     dxBranche=0;
	     dyBranche=dyBranche++;
	  FIN_SI
       FIN_SI
       idBrevet++;
     FIN_TANTQUE
  FIN_SI

  /* Affichage du PT de l'enfant */
  SI eleve>=0 ALORS
     AffichPTEnfant(eleve);
  FIN_SI


fin

/*--------------------------------------------*/

PROCEDURE AffichTours(int eleve, int idCat, int x, int y, char *titre)
debut
#define HAUTEUR    13

  int i;
  int dx=0,dy=0;
  int idBrevet; /* indice du brevet */
  int facteur,couleur;
  int nbBrevCatEnf;

  _wingotoxy(x,y+1);_winputs(titre);
  SI eleve<0 ALORS
     _wingotoxy(x+3,y+2);_winprintf("(%d%)",CalculPourcentageCategorie(idCat));
  SINON
     _wingotoxy(x+1,y+2);
     SI idCat>0 ALORS
	nbBrevCatEnf=NbBrevetsCategorieEnfant(eleve,idCat);
	SI L_NBREUSSITES()==0 ALORS
	   facteur=0;
	SINON
	   SI nbBrevCatEnf==0 ALORS
	      facteur=5*(L_NBBREVETSELEV(eleve)*NbReussitesCategorie(idCat))/
		      (L_NBREUSSITES());
	   SINON
	      facteur=(L_NBBREVETSELEV(eleve)*NbReussitesCategorie(idCat))/
		      (nbBrevCatEnf*L_NBREUSSITES());
	   FIN_SI
	FIN_SI

	LORSQUE facteur VAUT
	   SOIT 0 :
	   SOIT 1 :
		    FIN_SOIT
	   SOIT 2 : _winputs("-");
		    FIN_SOIT
	   SOIT 3 : _winputs("--");
		    FIN_SOIT
	   SOIT 4 : _winputs("---");
		    FIN_SOIT
	   SOIT 5 : _winputs("----");
		    FIN_SOIT
	   AUTRE  : _winputs("-----");
	FIN_LORSQUE
     FIN_SI
  FIN_SI

  i=1;
  TANTQUE i<=L_NBBREVETS() FAIRE
    idBrevet=brevetsClasses[i];
    SI idBrevet!=PAS_DE_BREVET ET
       (L_NBDETENTEURS(idBrevet)>=0 ET L_IDCATEGORIE(idBrevet)==idCat)
	 ALORS
       AffichBrevet(x+dx,y-dy,eleve,idBrevet,VRAI,couleur);
       dx++;
       SI dx>=HAUTEUR ALORS
	  dx=0;
	  dy=dy++;
       FIN_SI
    FIN_SI
    i++;
  FIN_TANTQUE

fin

/*--------------------------------------------*/

PROCEDURE AffichGraphisme(int eleve, int arbreClasse)
debut
  EteintCurseurSouris();

  SI L_MODECAT()==MODE_SANS_CATEGORIE ALORS
     AffichArbre(eleve,arbreClasse);
  SINON
     ClasseParNbDetenteurs(brevetsClasses);

/*     SI L_ORDRE()!=ORDRE_CHRONO ALORS
       ClasseParOrdreAcquisition(brevetsClasses);
     FIN_SI*/
     AffichTours(eleve,0,1,6,Categorie[0].Libelle);
     AffichTours(eleve,1,17,6,Categorie[1].Libelle);
     AffichTours(eleve,2,33,6,Categorie[2].Libelle);
     AffichTours(eleve,3,49,6,Categorie[3].Libelle);
     AffichTours(eleve,4,65,6,Categorie[4].Libelle);
     AffichTours(eleve,5,1,12,Categorie[5].Libelle);
     AffichTours(eleve,6,17,12,Categorie[6].Libelle);
     AffichTours(eleve,7,33,12,Categorie[7].Libelle);
     AffichTours(eleve,8,49,12,Categorie[8].Libelle);
     AffichTours(eleve,9,65,12,Categorie[9].Libelle);
     AffichTours(eleve,10,1,18,Categorie[10].Libelle);
     AffichTours(eleve,11,17,18,Categorie[11].Libelle);
     AffichTours(eleve,12,33,18,Categorie[12].Libelle);
     AffichTours(eleve,13,49,18,Categorie[13].Libelle);
     AffichTours(eleve,-1,65,18,"Non rang");
  FIN_SI

  AllumeCurseurSouris();

fin


