#include "bingo.h"


FONCTION int SelectEnfant(int idMotDePasse, int brevetRelatif, char *titre)
/* 1er param : Si VRAI demande du mot de passe */
/* 2me param : indice du brevet relatif, s'il est donn (diffrent de NON_INIT) */
/* la selection donne des informations sur l'obtention de ce brevet pour */
/* chaque enfant de la liste */


debut
  int idSelect,idBrevet,i,cr,idEleve,change,idEnfant;
  CHOICE *select;
  int valid=FAUX, tampon;
  char surnom[LG_SURNOM_ELEVE+3];
  int listePrenomsTrie[NB_MAX_ELEVES];
  char nomElevePrec[LG_SURNOM_ELEVE+1], nomEleveSuiv[LG_SURNOM_ELEVE+1];

  /* classement dans l'ordre alpha des prnoms */
  idEleve=0;
  TANTQUE idEleve<L_NBELEVES() FAIRE
     listePrenomsTrie[idEleve]=idEleve;
     idEleve++;
  FIN_TANTQUE

  change=VRAI;
  TANTQUE change==VRAI FAIRE
     change=FAUX;
     idEleve=1;
     TANTQUE idEleve<L_NBELEVES() FAIRE

	nomElevePrec[0]='\0';
	COPIER(nomElevePrec,L_SURNOMELEVE(listePrenomsTrie[idEleve-1]));

	nomEleveSuiv[0]='\0';
	COPIER(nomEleveSuiv,L_SURNOMELEVE(listePrenomsTrie[idEleve]));

	SI strcmp(nomEleveSuiv,nomElevePrec)<0 ALORS
	   tampon=listePrenomsTrie[idEleve-1];
	   listePrenomsTrie[idEleve-1]=listePrenomsTrie[idEleve];
	   listePrenomsTrie[idEleve]=tampon;
	   change=VRAI;
        FIN_SI
	idEleve++;
     FIN_TANTQUE
  FIN_TANTQUE

  _wingotoxy(2,2);
  _winputs(titre);

  /* Selection de l'lve */
  i=0;
  idBrevet=abs(brevetRelatif);
  TANTQUE i<L_NBELEVES() FAIRE
     /* On met une '*' devant les enfants qui ont dj russi le brevet */
     /* et un '-' devant les enfants qui ont le brevet en projet */
     idEnfant=listePrenomsTrie[i];
     SI brevetRelatif!=NON_INIT ALORS

	LectureDuPT(idEnfant,NON_INIT);
	cr=BrevetEstDansPT(idBrevet);
        LORSQUE cr VAUT
	   SOIT 1 : COPIER(surnom,"- ");
		    strcat(surnom,L_SURNOMELEVE(idEnfant));
                    FIN_SOIT
	   AUTRE  : COPIER(surnom,L_SURNOMELEVE(idEnfant));
                    FIN_SOIT
        FIN_LORSQUE

	cr=EnfantABrevet(idEnfant,idBrevet);
	SI cr==1 ALORS
	   COPIER(surnom,"* ");
	   strcat(surnom,L_SURNOMELEVE(idEnfant));
	FIN_SI

     SINON
	COPIER(surnom,L_SURNOMELEVE(idEnfant));
     FIN_SI

     SI i==0 ALORS
        select=_choiceadd(surnom);
     SINON
        _choiceadd(surnom);
     FIN_SI
     i++;
  FIN_TANTQUE
  _choiceend();

  idSelect=_choiceread(2,3,LG_SURNOM_ELEVE+5,16,1,select);

  _choicedispose(select);

  SI idSelect>=0 ALORS
     SI idSelect>=L_NBELEVES() ALORS
	idSelect=-1;
     SINON
        SI idMotDePasse==VRAI ALORS
	   valid=MotDePasse(listePrenomsTrie[idSelect],6,20);
           SI valid==FAUX ALORS
	      idSelect=-1;
           FIN_SI
        FIN_SI
     FIN_SI
  FIN_SI

  SI idSelect>=0 ALORS
     retour listePrenomsTrie[idSelect];
  FIN_SI
  retour idSelect;

fin

/************************************************/

PROCEDURE AjoutEleves(void)
debut
  windows *W_ajoutEleve;
  char prenom[LG_NOM_ELEVE+1];
  char nom[LG_NOM_ELEVE+1];
  char surnom[LG_SURNOM_ELEVE+1];
  char passe[LG_MOT_PASSE+1];
  char nomFic[LG_FIC_EXT+1];
  int cr=OK, idEleve;
  FILE *eleveFic;
  char repertoire[LG_PATH+1];

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  /* saisie des lves */

  W_ajoutEleve=_wincreate(X1_AFF_BREVETS,3,DX_AFF_BREVETS,21,
                       SIMPLE,ATTRNORMAL,ATTRBORDER,
                       "Saisie des lves",ATTRTITLE);
  _winselect(W_ajoutEleve);
  cr=OK;

  TANTQUE cr!=F4 ET L_NBELEVES()<NB_MAX_ELEVES FAIRE

    _winclrscr();

    SI cr!=NOK ALORS
       memset(prenom,' ',LG_NOM_ELEVE);
       prenom[LG_NOM_ELEVE]='\0';
       memset(nom,' ',LG_NOM_ELEVE);
       nom[LG_NOM_ELEVE]='\0';
       memset(surnom,' ',LG_SURNOM_ELEVE);
       surnom[LG_SURNOM_ELEVE]='\0';
       memset(passe,' ',LG_MOT_PASSE);
       passe[LG_MOT_PASSE]='\0';
       memset(nomFic,' ',LG_FIC);
       nomFic[LG_FIC]='\0';
    SINON
       COPIER(nomFic,strtok(nomFic,"."));
    FIN_SI

    _wingotoxy(31,2);
    _winprintf("%d",L_NBELEVES()+1);
    SI L_NBELEVES()+1>1 ALORS
       _winputs("me enfant");
    SINON
      _winputs("er enfant");
    FIN_SI
    _wingotoxy(11,3);_winputs("PRENOM");
    _getadd(7,4,STRING,prenom,0,"");
    _getadd_button(19,12," VALIDER (F10) ",F10,ON, 1,0,"Validation la saisie : F4");
    _getadd_button(45,12," RETOUR (F4) ",F4,ON, 1,0,"Quitter la saisie : F10");
     cr=_getread(NORMAL_MODE);
    _getdispose();

    SI cr==F10 ALORS
       _wingotoxy(61,3);_winputs("NOM");
       _getadd(55,4,STRING,nom,0,"");

       _wingotoxy(32,5);_winputs("PRENOM USUEL");
       COPIER(surnom,prenom);
       _getadd(31,6,STRING,surnom,0,"");

       SuppAccent(prenom);
       _wingotoxy(8,7); _winputs("MOT DE PASSE");
       strncpy(passe,prenom,LG_MOT_PASSE);
       strupr(passe);
       _getadd(9,8,STRING,passe,0,"");
       _getupper();

       _wingotoxy(55,7);_winputs("NOM DU FICHIER");
       strncpy(nomFic,prenom,LG_FIC);
       strupr(nomFic);
       _getadd(58,8,STRING,nomFic,0,"Ce fichier stocke les brevets dtenus par l'lve.");

       _getadd_button(19,12," VALIDER (F10) ",F10,ON, 1,0,"Validation la saisie : F4");
       _getadd_button(45,12," RETOUR (F4) ",F4,ON, 1,0,"Quitter la saisie : F10");

       _wingotoxy(1,15);
       _winputs(" Le PRENOM USUEL permettra de distinguer 2 lves ayant le mme prnom.\n");
       _winputs(" Exemple : MlanieB et MlanieG\n");

       cr=_getread(NORMAL_MODE);
       _getdispose();
    FIN_SI

    SI cr==F10 ALORS

       idEleve=L_NBELEVES();

       /* ouverture du fichier */
       COPIER(nomFic,ArretEspace(nomFic));
       SI (nomFic)[0]!='\0' ALORS
	  strcat(nomFic,".TXT");
       FIN_SI

       SI access(nomFic,0)==0 ET nomFic[0]!='\0' ALORS
	  Message(13,ATTRTITLE,NON_INIT,"\n\n   Ce nom du fichier est dj utilis !");
          cr=NOK;
       FIN_SI

       SI cr!=NOK ALORS
	  COPIER(prenom,ArretEspace(prenom));
	  E_PRENOMELEVE(idEleve,prenom);
	  COPIER(nom,ArretEspace(nom));
	  E_NOMELEVE(idEleve,nom);
	  COPIER(surnom,ArretEspace(surnom));
	  E_SURNOMELEVE(idEleve,surnom);
	  COPIER(passe,ArretEspace(passe));
	  E_MOTPASSE(idEleve,passe);

          SI prenom[0]=='\0' ALORS
             memset(prenom,' ',LG_NOM_ELEVE);
             prenom[LG_NOM_ELEVE]='\0';
	     cr=NOK;
	  FIN_SI
          SI nom[0]=='\0' ALORS
             memset(nom,' ',LG_NOM_ELEVE);
             nom[LG_NOM_ELEVE]='\0';
             cr=NOK;
          FIN_SI
          SI surnom[0]=='\0' ALORS
             memset(surnom,' ',LG_SURNOM_ELEVE);
             surnom[LG_SURNOM_ELEVE]='\0';
             cr=NOK;
          FIN_SI
          SI passe[0]=='\0' ALORS
              memset(passe,' ',LG_MOT_PASSE);
              passe[LG_MOT_PASSE]='\0';
              cr=NOK;
          FIN_SI
          SI nomFic[0]=='\0' ALORS
             memset(nomFic,' ',LG_FIC);
             nomFic[LG_FIC]='\0';
             cr=NOK;
	  FIN_SI
          SI cr==NOK ALORS
	     Message(13,ATTRTITLE,NON_INIT,"\n\n   Les champs doivent tous tre saisis !");
          FIN_SI
       FIN_SI

       SI cr!=NOK ALORS

          eleveFic=fopen(nomFic,"wt");
          SI eleveFic==NULL ALORS
	     Message(13,(COULEUR5<<4)+COULEUR10,NON_INIT,"\n\n      ERREUR FICHIER");
          SINON
	     fclose(eleveFic);
	     E_NOMFIC(idEleve,nomFic);
	     E_NBELEVES(idEleve+1);
	     AffichBandeau();
          FIN_SI
       FIN_SI
    FIN_SI

  FIN_TANTQUE

  SI L_NBELEVES()>=NB_MAX_ELEVES ALORS
     Message(13,ATTRTITLE,NON_INIT,"\n\n      Le nombre maximum d'lve est atteint");
  FIN_SI

  AllumeCurseurSouris();
 _windispose(W_ajoutEleve);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

 EnregFicEleves(-1);

fin

/*--------------------------------------------*/
FONCTION int DernierBrevetEnfant(int idBrevet)
debut
  int idEnfant;

  idEnfant=0;
  TANTQUE idEnfant<L_NBELEVES() FAIRE
     SI L_BREVELEV(idEnfant,L_NBBREVETSELEV(idEnfant))==idBrevet ALORS
	retour VRAI;
     FIN_SI
     idEnfant++;
  FIN_TANTQUE
  retour FAUX;
fin


/*--------------------------------------------*/

FONCTION EnfantABrevet(int idEnfant, int idBrevet)
	 /* La fonction retourne 1 si l'enfant a le brevet */
	 /*                      -1 si l'enfant a deja passe le brevet */
	 /*                      0 n'a pas pass le brevet */

debut
  int i;

  i=1;
  TANTQUE i<=L_NBBREVETSELEV(idEnfant) FAIRE
    SI L_BREVELEV(idEnfant,i)==idBrevet ALORS
       retour 1;
    FIN_SI
    SI L_BREVELEV(idEnfant,i)==(-1)*idBrevet ALORS
       retour -1;
    FIN_SI
    i++;
  FIN_TANTQUE

  retour 0;
fin


/*--------------------------------------------*/

FONCTION int NbBrevetsCategorieEnfant(int idEnfant, int idCat)
debut
  int i,nb=0;

  i=1;
  TANTQUE i<=L_NBBREVETSELEV(idEnfant) FAIRE
    SI L_IDCATEGORIE(L_BREVELEV(idEnfant,i))==idCat ET
       L_BREVELEV(idEnfant,i)>0 ALORS
       nb++;
    FIN_SI
    i++;
  FIN_TANTQUE

  retour nb;
fin


/*--------------------------------------------*/

