#include "bingo.h"


/* *************************************************************** */

/*                  MENU  "moi"                                    */

/* *************************************************************** */

PROCEDURE ViderBoiteEnfant(int idEnfant)

debut
  char titre[80];
  char repertoire[LG_PATH+1];
  char nomFic[LG_FIC_EXT+1];
  FILE *ptFic;

  SI idEnfant<0 ALORS retour;
  FIN_SI

  sprintf(titre,"%s, es-tu sur que tu veux vider ta bote aux lettres ?",L_SURNOMELEVE(idEnfant));

  SI _mesdisplay(titre)==FALSE ALORS
     retour;
  FIN_SI

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  SI chdir("msg")!=0 ALORS   /* aucune boite n'a t cr */
     retour;
  FIN_SI

  COPIER(nomFic,L_NOMFIC(idEnfant));
  nomFic[strlen(nomFic)-4]='\0'; /* on supprime l'extension .txt */
  strcat(nomFic,".txt");

  unlink(nomFic);
  ptFic=fopen(nomFic,"wt");
  fclose(ptFic);

  sprintf(titre,"\n\n\n\n      La boite aux lettres de %s a t vide.",L_PRENOMELEVE(idEnfant));

  Message(ATTRTITLE,NON_INIT,titre);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

fin

/* ------------------------------------------------------------------ */

FONCTION int LireBoite(int idIndividu)
debut
  int c,y,i;
  char repertoire[LG_PATH+1];
  char ligne[LG_LIGNE];
  char nomFic[LG_FIC_EXT+1];
  FILE *ptFic;
  int courrier=FAUX;

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  SI chdir("msg")!=0 ALORS
     mkdir("msg");
     chdir("msg");
  FIN_SI

  SI L_TYPEACCES()==ACCES_INSTIT ALORS
     COPIER(nomFic,L_NOM_INSTIT());
  SINON
     COPIER(nomFic,L_NOMFIC(idIndividu));
     nomFic[strlen(nomFic)-4]='\0'; /* on supprime l'extension .txt */
  FIN_SI

  strcat(nomFic,".txt");

  i=1;
  SI (ptFic=fopen(nomFic,"rt"))!=NULL ALORS
     SI fgets(ligne,LG_LIGNE,ptFic)!=NULL ALORS
	y=3;
	_winattr(ATTRSELECT);
	SI L_TYPEACCES()==ACCES_INSTIT ALORS
	   _winprintf("        Bonjour %s, tu as du courrier !             \n\n",L_NOM_INSTIT());
	SINON
	   _winprintf("        Bonjour %s, tu as du courrier !             \n\n",L_PRENOMELEVE(L_TYPEACCES()));
	FIN_SI
	_winattr(ATTRNORMAL);
	REPETER
	   SI y>17 ALORS
	      _winputs("\n               Appuyer sur une touche pour visualiser la suite");
	      getch();
	      _winclrscr();
	      y=0;
	   FIN_SI
	   SI i==1 ALORS
	      _winattr(ATTRSELECT);
	   SINON
	      _winattr(ATTRNORMAL);
	   FIN_SI
	   _winprintf("%s",ligne);
	   i++;
	   SI i==4 ALORS
	      i=1;
	   FIN_SI
	   y++;

	JUSQUA fgets(ligne,LG_LIGNE,ptFic)==NULL FIN_REPETER

	courrier=VRAI;
    FIN_SI
    fclose(ptFic);
  FIN_SI

  SI courrier==FAUX ALORS
     _winattr(ATTRSELECT);
     SI L_TYPEACCES()==ACCES_INSTIT ALORS
	_winprintf("  Bonjour %s, tu n'as pas reu de message pour l'instant !          \n",L_NOM_INSTIT());
     SINON
	_winprintf("  Bonjour %s, tu n'as pas reu de message pour l'instant !          \n",L_PRENOMELEVE(L_TYPEACCES()));
     FIN_SI
     _winattr(ATTRNORMAL);
  FIN_SI

  c=0;
  REPETER
    c=_kbdread();
  JUSQUA c!=0 FIN_REPETER

  L_REPCOURANT(repertoire);
  chdir(repertoire);

  LORSQUE c VAUT
     SOIT F5 : EcrireA(0);
	       FIN_SOIT
     SOIT F6 : EcrireA(1);
	       FIN_SOIT
  FIN_LORSQUE


  retour courrier;

fin

/* ------------------------------------------------------------------ */

PROCEDURE VoirMaBoite(int idEnfant)
debut
  windows *W_boite;
  char titre[80];
  char far *barreFonc=NULL;
  char nomBarre[80];
  int courrier;

  sprintf(titre,"Bote aux lettres de %s %s",L_PRENOMELEVE(idEnfant),L_NOMELEVE(idEnfant));

  W_boite=_wincreate(2,3,78,21,SIMPLE,ATTRNORMAL,ATTRBORDER,titre,ATTRTITLE);
  _winselect(W_boite);
  _winclrscr();

  sprintf(nomBarre," Envoyer un message  quelqu'un (F5),  %s (F6)",L_NOM_INSTIT());
  barreFonc=_helpbarcreate(nomBarre);
  _helpbarshow(barreFonc);

  courrier=LireBoite(idEnfant);

  _helpbardispose(barreFonc);
  _windispose(W_boite);

  SI courrier==VRAI ALORS
     SI _mesdisplay("Veux-tu vider ta bote aux lettres ?")==VRAI ALORS
	ViderBoiteEnfant(idEnfant);
     FIN_SI
  FIN_SI

fin

/* ------------------------------------------------------------------ */

PROCEDURE far LoginInstit(int clef)
debut
  CodeInstit();
  GestEvts(GEST_ARBRE);
fin

PROCEDURE VoirBoiteInstit()
debut
  windows *W_boite;
  char titre[80];
  char far *barreFonc=NULL;
  char nomBarre[80];
  int courrier;

  sprintf(titre,"Bote aux lettres de %s ",L_NOM_INSTIT());

  W_boite=_wincreate(2,3,78,21,SIMPLE,ATTRNORMAL,ATTRBORDER,titre,ATTRTITLE);
  _winselect(W_boite);
  _winclrscr();

  sprintf(nomBarre," Envoyer un message  quelqu'un (F5),  %s (F6)",L_NOM_INSTIT());
  barreFonc=_helpbarcreate(nomBarre);
  _helpbarshow(barreFonc);

  courrier=LireBoite(-1);

  _helpbardispose(barreFonc);
  _windispose(W_boite);

  SI courrier==VRAI ALORS
     SI _mesdisplay("Veux-tu vider ta bote aux lettres ?")==VRAI ALORS
	ViderBoiteInstit();
     FIN_SI
  FIN_SI

fin


PROCEDURE ViderBoiteInstit()
debut
  char titre[80];
  char repertoire[LG_PATH+1];
  char nomFic[LG_FIC_EXT+1];
  FILE *ptFic;

  sprintf(titre,"%s, es-tu sur que tu veux vider ta bote aux lettres ?",L_NOM_INSTIT());

  SI _mesdisplay(titre)==FALSE ALORS
     retour;
  FIN_SI

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  SI chdir("msg")!=0 ALORS   /* aucune boite n'a t cr */
     retour;
  FIN_SI

  COPIER(nomFic,L_NOM_INSTIT());
  strcat(nomFic,".txt");

  unlink(nomFic);
  ptFic=fopen(nomFic,"wt");
  fclose(ptFic);

  sprintf(titre,"\n\n\n\n      La boite aux lettres de %s a t vide.",L_NOM_INSTIT());

  Message(ATTRTITLE,NON_INIT,titre);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

fin

/* ------------------------------------------------------------------ */

PROCEDURE AuRevoir()
debut
  char mess[80];

  SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
     SI L_TYPEACCES()==ACCES_INSTIT ALORS
	sprintf(mess,"\n\n\n                  A bientt %s !",L_NOM_INSTIT());
	Message(ATTRTITLE,NON_INIT,mess);
     SINON
	sprintf(mess,"\n\n\n                  A bientt %s !",L_PRENOMELEVE(L_TYPEACCES()));
	Message(ATTRTITLE,L_TYPEACCES(),mess);
     FIN_SI
     E_TYPEACCES(ACCES_NON_INIT);
     AffichBandeau();
  FIN_SI

fin

/* ------------------------------------------------------------------ */

PROCEDURE far Imprimer(int clef)
debut
  int idEnfant;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI L_TYPEACCES()==ACCES_INSTIT OU L_TYPEACCES()==ACCES_NON_INIT ALORS
     idEnfant=SelectEnfant(VRAI,NON_INIT,15,"QUI ?");
  SINON
     idEnfant=L_TYPEACCES();
  FIN_SI

  InitBrevets();
  InitEleves();
  ImprimeEnfant(idEnfant,clef);
fin

/*--------------------------------------------*/

PROCEDURE far ImprimerBlasonCategorie(int clef)
debut
  int idEnfant;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI L_TYPEACCES()==ACCES_INSTIT OU L_TYPEACCES()==ACCES_NON_INIT ALORS
     idEnfant=SelectEnfant(VRAI,NON_INIT,15,"QUI ?");
  SINON
     idEnfant=L_TYPEACCES();
  FIN_SI

  InitBrevets();
  InitEleves();
  ImprimeEnfantCategorie(idEnfant,VRAI);
fin

/* *************************************************************** */

/*                  MENU  "La classe"                              */

/* *************************************************************** */

PROCEDURE Groupe_AffichBrevet(int idBrev, FILE *ptFic)
debut
  int idCat;

  idCat=L_IDCATEGORIE(idBrev);
  fprintf(ptFic,"\n\n\n %s ",L_NOMBREVET(idBrev));
  _winprintf("\n\n %s",L_NOMBREVET(idBrev));
  SI L_IDCATEGORIE(idCat)!=AUCUNE_CATEGORIE ALORS
     fprintf(ptFic," => %s\n",Categorie[idCat].Libelle);
     _winprintf(" => %s\n",Categorie[idCat].Libelle);
  SINON
     fprintf(ptFic,"\n\n");
     _winprintf("\n");
  FIN_SI
  fprintf(ptFic,"\nReceveur(s): ");
fin

PROCEDURE GroupesDeTravail()
debut
  int tab[NB_MAX_BREVETS+1];
  FILE *ptLstGroupe;
  int i,j,k,idEnf,idBrev,trouve,premier,c=0 ,brevetTrouve;
  char chDate[30];
  int dejaPris[NB_MAX_ELEVES];
  windows *W_groupe;
  int y=0;

  AffichDate(chDate);

  W_groupe=_wincreate(X1_AFF_BREVETS,Y1_AFF_BREVETS,
                   DX_AFF_BREVETS,DY_AFF_BREVETS,
                   SIMPLE,ATTRNORMAL,ATTRBORDER,
		   "Echanges de savoirs",ATTRTITLE);
  _winselect(W_groupe);
  _winclrscr();

  ClasseParOrdreAlpha(tab,MODE_SANS_CATEGORIE);
  ptLstGroupe=fopen("ecran.txt","wt");
  SI ptLstGroupe==NULL ALORS
     SyntaxeErreur(ID_SEFE,"ecran.txt",0);
     retour;
  FIN_SI

  fprintf(ptLstGroupe,"ECHANGES DE SAVOIR\n\n%s\n\n",chDate);
  fprintf(ptLstGroupe,"\n\n");

  i=1;
  TANTQUE i<=L_NBBREVETS() ET c!=ESC FAIRE
     idBrev=tab[i];
     premier=VRAI;
     brevetTrouve=FAUX;
     idEnf=0;
     TANTQUE idEnf<L_NBELEVES() FAIRE
	dejaPris[idEnf]=FAUX;
	idEnf++;
     FIN_TANTQUE

     SI L_NIVEAUBREVET(idBrev)!=0 ET L_NBDETENTEURS(idBrev)!=0
	ET L_NBDETENTEURS(idBrev)!=L_NBELEVES() ALORS

	idEnf=0;
	TANTQUE idEnf<L_NBELEVES() FAIRE
	   j=1;trouve=FAUX;
	   SI dejaPris[idEnf]==FAUX ALORS
	      TANTQUE j<=L_NBBREVETSELEV(idEnf) ET PAS trouve FAIRE
		 SI abs(L_BREVELEV(idEnf,j)) == idBrev ALORS
		    trouve=VRAI;
		 FIN_SI
		 j++;
	      FIN_TANTQUE
	      SI PAS trouve ALORS
		 SI (L_NIVEAUBREVET(idBrev) &
		    CodageBinaire(L_NIVEAUELEVE(idEnf)))!=0 ALORS

		    SI premier==VRAI ALORS
		       Groupe_AffichBrevet(idBrev,ptLstGroupe);
		       brevetTrouve=VRAI;
		       premier=FAUX;
		       y=y+7;
		    FIN_SI

		    fprintf(ptLstGroupe,"%s, ",L_SURNOMELEVE(idEnf));
		    _winattr(ATTRSELECT);
		    _winprintf(" %s",L_SURNOMELEVE(idEnf));
		    _winattr(ATTRNORMAL);
		 FIN_SI
	      FIN_SI
	   FIN_SI
	   idEnf++;
	FIN_TANTQUE
     FIN_SI

     /* personnes ressources */
     SI brevetTrouve==VRAI ALORS
	_winattr(ATTRCHOICE);
	fprintf(ptLstGroupe,"\n\nPasseur(s): ");
	_winprintf("\nAnimateur(s):");
	k=0;
	TANTQUE k<L_NBELEVES() FAIRE
	   j=1;
	   TANTQUE j<=L_NBBREVETSELEV(k) FAIRE
	      SI L_BREVELEV(k,j) == idBrev ALORS
		 _winprintf("%s ",L_SURNOMELEVE(k));
		 fprintf(ptLstGroupe,"%s, ",L_SURNOMELEVE(k));
	      FIN_SI
	      j++;
	   FIN_TANTQUE
	   k++;
	FIN_TANTQUE
	_winattr(ATTRNORMAL);
     FIN_SI

     SI y>16 ALORS
	_winputs("\n             Appuie sur une touche");
	c=0;
	fclose(ptLstGroupe);
	REPETER
	  c=_kbdread();
	JUSQUA c!=0 FIN_REPETER
	ptLstGroupe=fopen("ecran.txt","at");
	_winclrscr();
	_wingotoxy(1,2);
	y=0;
     FIN_SI

     i++;
  FIN_TANTQUE

  fclose(ptLstGroupe);

  _windispose(W_groupe);

fin


/* -------------------------------------------------------- */

PROCEDURE far Nouvelles (int clef)
/* clef=0  => Voir les nouvelles russites
   clef=1  => Imprimer les nouvelles russites */

debut
  FILE *ptFic, *ptImp;
  char chDate[30];
  char ligne[LG_LIGNE];
  windows *W_liste;
  int y=0;
  char repertoire[LG_PATH+1];
  int nbLgn=0;


  /* ouverture du fichier */

  AffichDate(chDate);

  L_REPDONNEES(repertoire);
  chdir(repertoire);
  ptFic=fopen(FIC_NOUVELLES,"rt");

  SI clef==0 ALORS
     /* affichage */
     W_liste=_wincreate(X1_AFF_BREVETS,Y1_AFF_BREVETS,
			DX_AFF_BREVETS,DY_AFF_BREVETS,SIMPLE,ATTRNORMAL,ATTRBORDER,
			"Les dernires russites",ATTRTITLE);
    _winselect (W_liste);
    _winclrscr();
    y=y+3;

    TANTQUE fgets(ligne,LG_LIGNE,ptFic)!=NULL FAIRE
       _winputs(ligne);
       y++;
       SI y>16 ALORS
	  _winputs("\n       Appuyer sur une touche pour visualiser la suite");
	  getch();
	  _winclrscr();
	  y=0;
       FIN_SI
       nbLgn++;
    FIN_TANTQUE

    getch();
    _windispose(W_liste);

  SINON
     ptImp=fopen("prn","wt");
     TANTQUE fgets(ligne,LG_LIGNE,ptFic)!=NULL FAIRE
	fputs(ligne,ptImp);
	nbLgn++;
     FIN_TANTQUE
     fprintf(ptImp,"%c\n",12);
     fclose(ptImp);
     Message(ATTRTITLE,NON_INIT,"\n\nImpression russie des nouvelles russites.");
  FIN_SI

  fclose(ptFic);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

  SI nbLgn>2 ALORS
     SI L_TYPEACCES()==ACCES_INSTIT ALORS
	SI _mesdisplay("Veux-tu effacer ?")==VRAI ALORS
	   ReInitDernieresReussites(VRAI);
	FIN_SI
     FIN_SI
  FIN_SI

fin

/* ------------------------------------------------------------------ */

FONCTION int DetenteursBrevet(int idBrevet, int mode)
debut
#define NB_CPT 3
  FILE *fImp;
  windows *W_brev;
  int i,j,c=0,catBrev,cpt;
  int trouve, ficOuvert;
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+1];
  char far *barreFonc=NULL;
  char titre[80];
  char completTitre[80];
  char chNiveau[9+1];
  int idEnfant;
  int ReAffich=FAUX;
  int tab[NB_MAX_BREVETS+1];
  int idTab;


  ClasseParOrdreAlpha(tab,mode);
  /* recherche de l'indice dans le tableau */
  idTab=1;
  TANTQUE idTab<=L_NBBREVETS() ET tab[idTab]!=idBrevet FAIRE
     idTab++;
  FIN_TANTQUE

  REPETER
     SI idTab>L_NBBREVETS() ALORS idTab=1;
     FIN_SI
     SI idTab<=0 ALORS idTab=L_NBBREVETS();
     FIN_SI
     idBrevet=tab[idTab];
     SI (fImp=fopen("ecran.txt","wt"))!=NULL ALORS
	ficOuvert=VRAI;
     SINON
	ficOuvert=FAUX;
     FIN_SI

     SI idBrevet>L_NBBREVETS() ALORS
	idBrevet=1;
     FIN_SI

     sprintf(titre,"%s",L_NOMBREVET(idBrevet));
     catBrev=L_IDCATEGORIE(idBrevet);
     SI catBrev!=AUCUNE_CATEGORIE ALORS
	sprintf(completTitre," => %s",Categorie[catBrev].Libelle);
	strcat(titre,completTitre);
     FIN_SI

     SI L_NIVEAUBREVET(idBrevet) ALORS
	DecodeNiveau(L_NIVEAUBREVET(idBrevet),chNiveau);
	sprintf(completTitre,"(%s)",chNiveau);
	strcat(titre,completTitre);
     FIN_SI

     SI ficOuvert==VRAI ALORS
	fprintf(fImp,"%s",L_NOMBREVET(idBrevet));
     FIN_SI

     W_brev=_wincreate(X1_AFF_BREVETS,Y1_AFF_BREVETS,
                   DX_AFF_BREVETS,DY_AFF_BREVETS,
                   SIMPLE,ATTRNORMAL,ATTRBORDER,
		   titre,ATTRTITLE);
     _winselect(W_brev);
     _winclrscr();

     COPIER(titre,"");
     SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
	sprintf(titre,"  F3:entrer_russite    F5:crire    F6:crire_%s    F8:demander_aide",L_NOM_INSTIT());
     FIN_SI

     barreFonc=_helpbarcreate(titre);
     _helpbarshow(barreFonc);

     comment1[0]='\0';comment2[0]='\0';
     LitInfosBrevet(idBrevet,comment1,comment2);

     _winprintf(" %s %s\n",comment1,comment2);
     _winprintf("---------------------------------------------------------------------------\n");

     SI ficOuvert==VRAI ALORS
	fprintf(fImp,"%s %s\n",comment1,comment2);
	fprintf(fImp,"---------------------------------------------------------------------------\n");
     FIN_SI

     /* les enfants qui peuvent aider */

     SI L_NBDETENTEURS(idBrevet)==1 ALORS
	_winprintf("1 enfant peut aider : \n");
     SINON
	SI L_NBDETENTEURS(idBrevet)!=0 ALORS
	   _winprintf("%d enfants peuvent aider (%d%) :\n",L_NBDETENTEURS(idBrevet),L_NBDETENTEURS(idBrevet)*100/L_NBELEVES());
	   SI ficOuvert==VRAI ALORS
	      fprintf(fImp,"%d enfant(s) peut(peuvent) aider (%d) : \n",L_NBDETENTEURS(idBrevet),L_NBDETENTEURS(idBrevet)*100/L_NBELEVES());
	   FIN_SI
	SINON
	   _winputs("Personne n'a ce brevet.\n");
	FIN_SI
     FIN_SI

     _winattr(ATTRSELECT);
     i=0;cpt=0;
     TANTQUE i<L_NBELEVES() FAIRE
	j=1;trouve=FAUX;
	TANTQUE j<=L_NBBREVETSELEV(i) ET PAS trouve FAIRE
	   SI L_BREVELEV(i,j) == idBrevet ALORS
	      _winprintf("%15s ",L_SURNOMELEVE(i));
	      SI ficOuvert==VRAI ALORS
		 fprintf(fImp,"%15s ",L_SURNOMELEVE(i));
	      FIN_SI
	      cpt++;
	      SI cpt==NB_CPT ALORS
		 _winputs("\n");
		 cpt=0;
	      FIN_SI
	      trouve=VRAI;
	   FIN_SI
	   j++;
	FIN_TANTQUE
	i++;
     FIN_TANTQUE

     _winattr(ATTRNORMAL);
     _winprintf("\n\nBingo a propos de travailler sur ce brevet  :\n");
     SI ficOuvert==VRAI ALORS
	fprintf(fImp,"\n\nBingo a propos de travailler sur ce brevet  :\n");
     FIN_SI
     _winattr(ATTRSELECT);
     i=0;cpt=0;
     TANTQUE i<L_NBELEVES() FAIRE
	SI (EnfantABrevet(i,idBrevet)!=1) ET
	   (L_NIVEAUBREVET(idBrevet) & CodageBinaire(L_NIVEAUELEVE(i)))!=0 ALORS
	   _winprintf("%15s ",L_SURNOMELEVE(i));
	   SI ficOuvert==VRAI ALORS
	      fprintf(fImp,"%15s ",L_SURNOMELEVE(i));
	   FIN_SI
	   cpt++;
	   SI cpt==NB_CPT ALORS
	      _winputs("\n");
	      cpt=0;
	   FIN_SI
	FIN_SI
	i++;
     FIN_TANTQUE
     _winattr(ATTRNORMAL);

     SI ficOuvert==VRAI ALORS
	fclose(fImp);
     FIN_SI

     c=0;
     REPETER
       c=_kbdread();
     JUSQUA c!=0 FIN_REPETER

     LORSQUE c VAUT
      SOIT F1  : c=0;
		 SI L_TYPEACCES()==ACCES_INSTIT OU
		    L_TYPEACCES()==ACCES_NON_INIT ALORS
		    _helpdisplay(4);
		 SINON
		    _helpdisplay(5);
		 FIN_SI
		 FIN_SOIT
	SOIT 'M':
	SOIT 'm': ModifierBrevet(MODIFIER+10*idBrevet);
		  FIN_SOIT
	SOIT F5 : SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
		     EcrireA(0);
		  FIN_SI
		  FIN_SOIT
	SOIT F6 : SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
		     EcrireA(1);
		  FIN_SI
		  FIN_SOIT
      SOIT F3 :
		InitBrevets();
		InitEleves();
		c=0;
		SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
		   idEnfant=L_TYPEACCES();
		   SI EnfantABrevet(idEnfant,idBrevet)<=0 ALORS
		      AjouBrevFicEnf(idEnfant, idBrevet, REUSSI,VRAI);
		   FIN_SI
		SINON
		   SI L_TYPEACCES()==ACCES_INSTIT ALORS
		      AffectUnBrevet(idBrevet,REUSSI);
		   FIN_SI
		FIN_SI
		ReAffich=VRAI;
		FIN_SOIT

      SOIT DEL :c=0;
		InitBrevets();
		InitEleves();
		SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
		   idEnfant=L_TYPEACCES();
		   SI EnfantABrevet(idEnfant,idBrevet)>0 ALORS
		      SuppBrevFicEnf(idEnfant,idBrevet, VRAI);
		      ReAffich=VRAI;
		   FIN_SI
		SINON
		   SI L_TYPEACCES()==ACCES_INSTIT ALORS
		      DesaffectUnBrevet(idBrevet);
		      ReAffich=VRAI;
		   FIN_SI
		FIN_SI
		FIN_SOIT

       SOIT F8  :  c=0;
		   SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
		      idEnfant=L_TYPEACCES();
		      InitBrevets();
		      InitEleves();
		      DemanderUneAide(idBrevet,idEnfant);
		   FIN_SI
		   FIN_SOIT

	SOIT PGUP   : idTab--;
		      FIN_SOIT
	SOIT PGDN   : idTab++;
		      FIN_SOIT
     FIN_LORSQUE

     _helpbardispose(barreFonc);
     _windispose(W_brev);

  JUSQUA c==ESC OU c==CR FIN_REPETER

  retour ReAffich;

fin


/*--------------------------------------------*/

PROCEDURE far VoirBrevets()
debut
  int id=1;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()==VRAI ALORS
     InitBrevets();
     SelectBrevet(&id);
  FIN_SI

fin



/* *************************************************************** */

/*                  MENU  "instit"                                 */

/* *************************************************************** */

PROCEDURE far VoirTousArbres(int clef)
debut
  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()==VRAI ALORS
     GestEvts(GEST_TOUS);
  FIN_SI

fin

/* ------------------------------------------------------------------ */
PROCEDURE far VoirBlasonDansArbre(int clef)
debut
  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()==VRAI ALORS
     GestEvts(GEST_TOUS_ARBRE);
  FIN_SI

fin


/*----------------------------------------------------------------*/

PROCEDURE far ReInitDernieresReussites ()
debut
  FILE *ptFic;
  char chDate[30];
  char repertoire[LG_PATH+1];

  SI CodeInstit()==VRAI ALORS
     AffichDate(chDate);
     L_REPDONNEES(repertoire);
     chdir(repertoire);
     ptFic=fopen(FIC_NOUVELLES,"wt");
     fprintf(ptFic,"Les russites depuis le %s\n\n",chDate);
     fclose(ptFic);
     L_REPCOURANT(repertoire);
     chdir(repertoire);
  FIN_SI
fin

/*----------------------------------------------------------------*/

PROCEDURE far EnleverBrevet ()
debut
  int idEnfant;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  idEnfant=SelectEnfant(VRAI,NON_INIT,15,"QUI ?");
  SI idEnfant>=0 ALORS
     InitBrevets();
     InitEleves();
     SuppBrevEnf(idEnfant);
     GestEvts(idEnfant);
  FIN_SI
fin


/*--------------------------------------------*/

PROCEDURE ImprimeBrevets(int clef)
/* clef=0 : on imprime les brevets avec aucun dtenteur ordre alpha
   clef=1 : on imprime les brevets avec au moins 1 dtenteur ordre alpha
   clef=2 : on imprime tous les brevets par catgorie */
debut
  FILE *ptImp;
  int tab[NB_MAX_BREVETS+1];
  int i,j,idBrevTrie, idCat, idCatAnc=99;
  char chDate[30];

  ptImp=fopen("prn","wt");
  SI ptImp==NULL ALORS
     retour;
  FIN_SI

  AffichDate(chDate);

  LORSQUE clef VAUT
     SOIT 1 : fprintf(ptImp,"LES BREVETS DE L'ARBRE DE LA CLASSE : %s\n\n",chDate);
	      ClasseParOrdreAlpha(tab,MODE_SANS_CATEGORIE);
	      ClasseParNiveau(tab);
	      FIN_SOIT
     SOIT 0 : fprintf(ptImp,"LA RESERVE DES BREVETS : %s\n\n",chDate);
	      ClasseParOrdreAlpha(tab,MODE_SANS_CATEGORIE);
	      ClasseParNiveau(tab);
	      FIN_SOIT
     SOIT 2 : fprintf(ptImp,"LES BREVETS CLASSES PAR CATEGORIE : %s\n\n",chDate);
	      ClasseParOrdreAlpha(tab,MODE_CATEGORIE);
	      FIN_SOIT
  FIN_LORSQUE

  /* boucle sur les brevets */
  idBrevTrie=1;j=0;
  TANTQUE idBrevTrie<=L_NBBREVETS() FAIRE
     i=tab[idBrevTrie];
     SI (L_NBDETENTEURS(i)>0 ET clef==1) OU
	(L_NBDETENTEURS(i)==0 ET clef==0) ALORS
	j++;
	fprintf(ptImp,"%02d %s ",j,L_NOMBREVET(i));
	SI L_IDCATEGORIE(i)!=AUCUNE_CATEGORIE ALORS
	  fprintf(ptImp," : %s",Categorie[L_IDCATEGORIE(i)].Libelle);
	FIN_SI
	fprintf(ptImp,"\n");
     SINON
	SI clef==2 ALORS
	   idCat=L_IDCATEGORIE(i);
	   SI idCat!=idCatAnc ET idCat!=AUCUNE_CATEGORIE ALORS
	      fprintf(ptImp,"\n%s\n",Categorie[idCat].Libelle);
	      idCatAnc=idCat;
	   SINON
	      SI idCat!=idCatAnc ALORS
		 fprintf(ptImp,"Sans catgorie\n");
		 idCatAnc=idCat;
	      FIN_SI
	   FIN_SI
	   fprintf(ptImp,"%d\t%s\n",i,L_NOMBREVET(i));
	FIN_SI
     FIN_SI
     idBrevTrie++;
  FIN_TANTQUE

  fprintf(ptImp,"%c\n",12);
  fclose(ptImp);
fin

/*--------------------------------------------*/

PROCEDURE far AffichTousBlasons()
debut
  int idEnfant,c;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()!=VRAI ALORS
     retour;
  FIN_SI

  InitBrevets();
  InitEleves();

  idEnfant=0;
  TANTQUE idEnfant<L_NBELEVES() ET kbhit()!=ESC FAIRE
     c=ImprimeEnfant(idEnfant,FAUX);
     SI c==ESC ALORS
	retour;
     FIN_SI
     idEnfant++;
  FIN_TANTQUE
fin


/* --------------------------------------------------------- */

PROCEDURE far RangerBrevets()
debut
  int idBrevet,idCat,id=1;

#define NB_BREV_FEN  8

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()==VRAI ALORS

     EteintCurseurSouris();
     InitBrevets();

     SI L_NBBREVETS()==0 ALORS
        retour;
     FIN_SI

     REPETER
       idBrevet=SelectBrevet(&id);
       SI idBrevet>0 ALORS
          idCat=SelectCategorie(idBrevet);
	  ModifBrevetDansFicBrevet(idBrevet,idCat,
				   L_NIVEAUBREVET(idBrevet),L_NOMBREVET(idBrevet));
          E_ACCEPTIMPORT(IMPORT_NOK);
       FIN_SI
     JUSQUA idBrevet<0 FIN_REPETER

  FIN_SI
  AllumeCurseurSouris();

fin

/*--------------------------------------------*/

PROCEDURE far ModifCategories()
debut
  windows *W_modifCat;
  char nomCat[NB_MAX_CATEGORIE][LG_CATEGORIE+1];
  int i,x,y;
  int modif=FAUX;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()==VRAI ALORS

     W_modifCat=_wincreate(7,3,69,20,
                        SIMPLE,ATTRNORMAL,ATTRBORDER,"Renommer les catgories",ATTRTITLE);
     _winselect (W_modifCat);

     LectureFicCat();

     i=0;
     TANTQUE i<NB_MAX_CATEGORIE FAIRE
        SI i<7 ALORS
           x=2;
           y=3+i*2;
        SINON
           x=35;
           y=3+(i-7)*2;
        FIN_SI
        _wingotoxy(x,y);_winprintf("Catgorie n%2d : ",i+1);
        COPIER(nomCat[i],Categorie[i].Libelle);
        _getadd(x+17,y,STRING,nomCat[i],0,"Modifier la catgorie : appuyer sur Entre pour valider");
        i++;
     FIN_TANTQUE

     _wingotoxy(25,18);_winputs("Ctrl F4 pour quitter !");

     _getread(DB_MODE);

     /* Modifications suite  la saisie */
     i=0;
     TANTQUE i<NB_MAX_CATEGORIE FAIRE
        SI strcmp(Categorie[i].Libelle,nomCat[i])!=0 ALORS
           modif=VRAI;
           COPIER(Categorie[i].Libelle,nomCat[i]);
        FIN_SI
	i++;
     FIN_TANTQUE

     SI modif==VRAI ALORS
        ModifFicCategorie();
        E_ACCEPTIMPORT(IMPORT_NOK);
     FIN_SI

     _windispose(W_modifCat);

  FIN_SI

fin

/* ------------------------------------------------------------------- */

PROCEDURE far AffectBrevets(int clef)
debut
  int idBrevet, id=1;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()==VRAI ALORS
     REPETER
       /* ractualisation ncessaire si maj sur autre ordi du reseau */
       InitBrevets();
       InitEleves();

       id=1;
       idBrevet=SelectBrevet(&id);

       SI clef==A_ENLEVER ALORS
	  DesaffectUnBrevet(idBrevet);
       SINON
	  AffectUnBrevet(idBrevet,clef);
       FIN_SI

     JUSQUA idBrevet<0 FIN_REPETER

  FIN_SI
fin

/* ----------------------------------------------------------------- */

PROCEDURE far SupprimerBrevet(int clef)
debut
  int idBrevetRef,id=1,i, enf, nbBrevetsElev;
  char nomFic[12], nomFic2[12];
  char repertoire[LG_PATH+1];
  FILE *fp;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()!=VRAI ALORS
     retour;
  FIN_SI

  SI _mesdisplay("Supprimer un brevet ?")==FALSE ALORS
     retour;
  FIN_SI

  SI clef==0 ALORS
     idBrevetRef=SelectBrevet(&id);
  SINON
     idBrevetRef=clef;
  FIN_SI

  SI idBrevetRef<0 ALORS
     retour;
  FIN_SI

  DetenteursBrevet(idBrevetRef,MODE_SANS_CATEGORIE);

  /* suppression ventuelle du fichier d'informations du brevet */
  /* + renommage des autres fichiers */

  i=idBrevetRef;

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  itoa(i,nomFic,10);
  strcat(nomFic,".txt");
  unlink(nomFic);

  TANTQUE i<L_NBBREVETS() FAIRE
     itoa(i,nomFic,10);
     strcat(nomFic,".txt");
     itoa(i+1,nomFic2,10);
     strcat(nomFic2,".txt");
     rename(nomFic2,nomFic);
     /* ajout d'un espace pour que la date de modification change */
     fp=fopen(nomFic,"at");
     fputs(" ",fp);
     fclose(fp);
     i++;
  FIN_TANTQUE

  itoa(i,nomFic,10);
  strcat(nomFic,".txt");
  unlink(nomFic);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

  /* modification de la liste des blasons des enfants */

  enf=0;
  TANTQUE enf<L_NBELEVES() FAIRE
    i=1;
    nbBrevetsElev=L_NBBREVETSELEV(enf);
    TANTQUE i<=nbBrevetsElev FAIRE
       SI abs(L_BREVELEV(enf,i))==abs(idBrevetRef) ALORS
	  /* Decalage du tableau  partir du brevet trouve */
	  TANTQUE i<nbBrevetsElev FAIRE
	     E_BREVELEV(enf,i,L_BREVELEV(enf,i+1));
	     i++;
	  FIN_TANTQUE
	  E_NBBREVETSELEV(enf,nbBrevetsElev-1);
       FIN_SI
       i++;
    FIN_TANTQUE

    /* mise  jour du tableau des indices de brevets */
    i=1;
    TANTQUE i<=L_NBBREVETSELEV(enf) FAIRE
       SI abs(L_BREVELEV(enf,i))>abs(idBrevetRef) ALORS
	  SI L_BREVELEV(enf,i)>0 ALORS
	     E_BREVELEV(enf,i,L_BREVELEV(enf,i)-1);
	  SINON
	     E_BREVELEV(enf,i,L_BREVELEV(enf,i)+1);
	  FIN_SI
       FIN_SI
       i++;
    FIN_TANTQUE

    enf++;
  FIN_TANTQUE

  Message(ATTRTITLE,NON_INIT,"\nSuppression du brevet - %s - \n",L_NOMBREVET(idBrevetRef));

  /* modification des indices des brevets */
  i=idBrevetRef;
  TANTQUE i<L_NBBREVETS() FAIRE
     memcpy(&(TabBrevets[i]),
	    &(TabBrevets[i+1]),sizeof(T_BREVET));
     i++;
  FIN_TANTQUE

  E_NBBREVETS(L_NBBREVETS()-1);

  /* Sauvegarde des fichiers */
  EnregFicBrevets();

  enf=0;
  TANTQUE enf<L_NBELEVES() FAIRE
     EnregFicEnf(enf);
     enf++;
  FIN_TANTQUE

  EnregFicEleves(-1);



  /* Relecture des fichiers */

  InitBrevets();
  InitEleves();
fin

/* ----------------------------------------------------------------- */


PROCEDURE far ModifierBrevet(int clef)
/* clef%10 => MODIFIER ou AJOUTER
   clef/10 => numero de brevet ventuel */

debut
  windows *W_modifBrev;
  char nomGet[LG_NOM_BREVET+1];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+1];
  char nom[LG_NOM_BREVET+1];
  int idBrevet, id=1,niveau,categorie, cr;
  CHOICE *listeCat,*listeTypeBrev;
  char chaineNiveau[9+1];
  char saisie1[1], saisie2[1], saisie3[1], saisie4[1], saisie5[1],
       saisie6[1], saisie7[1], saisie8[1], saisie9[1];
  int fini=FAUX;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI

  SI CodeInstit()!=VRAI ALORS
     retour;
  FIN_SI

  REPETER
    InitBrevets();
    COPIER(chaineNiveau,"");
    SI (clef%10)==MODIFIER ALORS
       id=1;
       idBrevet=clef/10;
       SI idBrevet==0 ALORS
	  idBrevet=SelectBrevet(&id);
       SINON
	  fini=VRAI;
       FIN_SI
       SI idBrevet<=0 ALORS
	  retour;
       FIN_SI
       COPIER(nom,L_NOMBREVET(idBrevet));

       DetenteursBrevet(idBrevet, MODE_SANS_CATEGORIE);
       W_modifBrev=_wincreate(2,3,77,21,
			  SIMPLE,ATTRNORMAL,ATTRBORDER,"Modification d'un brevet",ATTRTITLE);
    SINON
       W_modifBrev=_wincreate(2,3,77,21,
			  SIMPLE,ATTRNORMAL,ATTRBORDER,"Cration d'un brevet",ATTRTITLE);
       memset(nom,' ',LG_NOM_BREVET);
       nom[LG_NOM_BREVET]='\0';

       idBrevet=L_NBBREVETS()+1;

       /* Par dfaut, pas de niveau */
       E_NIVEAUBREVET(idBrevet,0);
       /* Par dfaut, le brevet n'a pas de catgorie */
       E_IDCATEGORIE(idBrevet,AUCUNE_CATEGORIE);
    FIN_SI

    _winselect(W_modifBrev);
    _winclrscr();

    SI L_NBDETENTEURS(idBrevet) > 0 ALORS
       _wingotoxy(6,1);
       _winprintf("ATTENTION : Il y a %d dtenteur(s) du brevet !",L_NBDETENTEURS(idBrevet));
    FIN_SI

    /***************** nom du brevet **********************/

    _wingotoxy(2,3);_winputs("Nom du brevet : \n");
    memset(nomGet,' ',LG_NOM_BREVET);
    nomGet[LG_NOM_BREVET]='\0';
    strncpy(nomGet,nom,strlen(nom));

    _getadd(2+4,3,STRING,nomGet,0,"Nom du brevet");

    cr=_getread(NORMAL_MODE);
    COPIER(nomGet,SuppEspaceFin(nomGet));
    _getdispose();

    SI nomGet[0]=='\0' OU cr==CF4 ALORS
       _getdispose();
       _windispose(W_modifBrev);
       retour;
    FIN_SI

    /****************** choix de la catgorie **************************/

    SI L_NBCATEGORIE()>0 ALORS
       _wingotoxy(2,5);_winputs("Catgorie : ");
       SI L_IDCATEGORIE(idBrevet)>=0 ALORS
	  _winputs(Categorie[L_IDCATEGORIE(idBrevet)].Libelle);
       SINON
	  _winputs("Aucune");
       FIN_SI
       id=0;
       listeCat=_choiceadd(" Aucune ");
       TANTQUE id<L_NBCATEGORIE() FAIRE
	  _choiceadd(Categorie[id].Libelle);
	  id++;
       FIN_TANTQUE

       _choiceend();

       id=_choiceread(2,7,LG_CATEGORIE+5,5,0,listeCat);
       _choicedispose(listeCat);

       SI id==-1 ALORS
	  _getdispose();
	  _windispose(W_modifBrev);
	  retour;
       FIN_SI

       _wingotoxy(2+12,5);_winclreol();_wingotoxy(2+12,5);
       SI id>0 ALORS
	  categorie=id-1;
	  E_IDCATEGORIE(idBrevet,categorie);
	  _winprintf("%s",Categorie[categorie].Libelle);
       SINON
	  categorie=-1;
	  SI id==0 ALORS
	     E_IDCATEGORIE(idBrevet,AUCUNE_CATEGORIE);
	     _winputs("AUCUNE");
	  FIN_SI
       FIN_SI
    SINON
       categorie=-1;
       E_IDCATEGORIE(idBrevet,AUCUNE_CATEGORIE);
    FIN_SI

    /*************** brevet normal ou brevet  niveaux ? ***********************/
     _wingotoxy(40,5);
       SI L_NIVEAUBREVET(idBrevet) !=0 ALORS
	  _winputs("Brevet  niveaux");
       SINON
	  _winputs("Brevet normal");
       FIN_SI

    listeTypeBrev=_choiceadd(" Brevet normal ");
    _choiceadd(" Brevet  niveaux");
    id=_choiceread(30,7,25,2,0,listeTypeBrev);
    _choiceend();
    _choicedispose(listeTypeBrev);
    SI id==-1 ALORS
       _getdispose();
       _windispose(W_modifBrev);
       retour;
    FIN_SI

    _wingotoxy(40,5);_winclreol();_wingotoxy(40,5);

    SI id==1 ALORS
       _winputs("BREVET A NIVEAUX");
       /****************** choix des niveaux **************************/
       _wingotoxy(24,7);_winputs("Bingo le proposera pour les enfants qui");
       _wingotoxy(24,8);_winputs("sont dans les niveaux :              ");
       _wingotoxy(24,9);_winputs("  (0=NON ; 1=OUI)       1 2 3 4 5 6 7 8 9 ");
       cr=ESC;
       TANTQUE cr!=F10 FAIRE
	  niveau=L_NIVEAUBREVET(idBrevet);

	  DecodeNiveau(niveau,chaineNiveau);
	  saisie1[0]=chaineNiveau[0];saisie1[1]='\0';
	  _getadd(48,10,CHAR,saisie1,0,"");
	  _getpicture("9");
	  saisie2[0]=chaineNiveau[1];saisie2[1]='\0';
	  _getadd(48+2,10,CHAR,saisie2,0,"");
	  _getpicture("9");
	  saisie3[0]=chaineNiveau[2];saisie3[1]='\0';
	  _getadd(48+4,10,CHAR,saisie3,0,"");
	  _getpicture("9");
	  saisie4[0]=chaineNiveau[3];saisie4[1]='\0';
	  _getadd(48+6,10,CHAR,saisie4,0,"");
	  _getpicture("9");
	  saisie5[0]=chaineNiveau[4];saisie5[1]='\0';
	  _getadd(48+8,10,CHAR,saisie5,0,"");
	  _getpicture("9");
	  saisie6[0]=chaineNiveau[5];saisie6[1]='\0';
	  _getadd(48+10,10,CHAR,saisie6,0,"");
	  _getpicture("9");
	  saisie7[0]=chaineNiveau[6];saisie7[1]='\0';
	  _getadd(48+12,10,CHAR,saisie7,0,"");
	  _getpicture("9");
	  saisie8[0]=chaineNiveau[7];saisie8[1]='\0';
	  _getadd(48+14,10,CHAR,saisie8,0,"");
	  _getpicture("9");
	  saisie9[0]=chaineNiveau[8];saisie9[1]='\0';
	  _getadd(48+16,10,CHAR,saisie9,0,"");
	  _getpicture("9");
	  _getadd_button(67,10," OK ",F10,ON, 1,0,"Validation la saisie : F4");
	  cr=_getread(NORMAL_MODE);
	  niveau=atoi(saisie1)+2*atoi(saisie2)+4*atoi(saisie3)+8*atoi(saisie4)+
		 16*atoi(saisie5)+32*atoi(saisie6)+64*atoi(saisie7)+
		 128*atoi(saisie8)+256*atoi(saisie9);
       FIN_TANTQUE
       _getdispose();
       DecodeNiveau(niveau,chaineNiveau);

    SINON
      _winputs("Brevet normal");
      niveau=0;
      E_NIVEAUBREVET(idBrevet,niveau);
    FIN_SI

    /****************** choix des commentaires **************************/

    SI id!=-1 ALORS
       memset(comment1,' ',73);
       memset(comment2,' ',73);
       comment1[73]='\0';comment2[73]='\0';
       LitInfosBrevet(idBrevet,comment1,comment2);
       comment1[73]='\0';comment2[73]='\0';
       _wingotoxy(25,13);_winputs("Autres informations\n");
       _getadd(2,15,STRING,comment1,0,"Autres informations");
       _getadd(2,17,STRING,comment2,0,"Autres informations");
       _getread(NORMAL_MODE);
       _getdispose();

       /* traitement des modifications */
       SI (clef%10)==NOUVEAU ALORS
	  E_NBBREVETS(idBrevet);
       FIN_SI
       ModifBrevetDansFicBrevet(idBrevet,categorie,niveau,nomGet);
       SauveInfosBrevet(idBrevet,comment1,comment2);
       _getdispose();
       _windispose(W_modifBrev);
       DecodeNiveau(niveau,chaineNiveau);
       SI (clef%10)==MODIFIER ALORS

	  Message(ATTRTITLE,NON_INIT,"Modification de brevet russie : \n\n- nom : %s\n- Catgorie : %s\n- Niveau : %s\n- Commentaires : %s %s",
	       nomGet,categorie>=0?Categorie[categorie].Libelle:"Aucune",
	       niveau!=0?chaineNiveau:"",comment1,comment2);
       SINON
	  Message(ATTRTITLE,NON_INIT,"Cration de brevet russie : \n\n- nom : %s\n- Catgorie : %s\n- Niveau : %s\n- Commentaires : %s %s",
	       nomGet,categorie>=0?Categorie[categorie].Libelle:"Aucune",
	       niveau!=0?chaineNiveau:"",comment1,comment2);
       FIN_SI
    SINON
       _getdispose();
       _windispose(W_modifBrev);
       retour;
    FIN_SI

  JUSQUA fini==VRAI FIN_REPETER

fin

/* ----------------------------------------------------------- */
PROCEDURE far Sauvegarde(int clef)
debut
  /* Sauvegarde des blasons */
  ImprimeEnfant(NON_INIT,FAUX);
  ImprimeEnfantCategorie(NON_INIT,FAUX);

  /* Sauvegarde des listes de brevets */
  ListesBrevets();

  Message(ATTRMESSAGE,NON_INIT,"\n\nSauvegarde des fichiers 'blascat', 'blason.txt', 'brevcat.txt', 'brevalph.txt', 'brevcrea.txt'");
fin


/********************************************************************/

PROCEDURE far GestEvts(int clef)
debut
  int ancPosX,ancPosY,posX=0,posY=0,etatBouton=0,x=0,y=0,xTrouve=0,yTrouve=0;
  int idEnfant;
  int c=0;    /* caractere */
  int type;   /* REUSSI ou A_REPASSER */
  char nomBarre[100];
  int idBrevet=PAS_DE_BREVET;
  char far *barreFonc=NULL;
  int ReAffich=VRAI;
  windows *fenetre;
  int sortie=FAUX;
  int premierPassage=VRAI;
  char find[LG_NOM_BREVET+1];
  int arbreClasse=FAUX;

  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI
  LORSQUE clef VAUT
     SOIT GEST_TOUS   : idEnfant=0;
			arbreClasse=FAUX;
			FIN_SOIT
     SOIT GEST_TOUS_ARBRE : idEnfant=0;
			    arbreClasse=VRAI;
			    FIN_SOIT
     SOIT GEST_ARBRE :  idEnfant=-1;
			FIN_SOIT
     AUTRE           :  idEnfant=clef;
			FIN_SOIT
  FIN_LORSQUE

  SI idEnfant>=0 ALORS
     AttrFenPrinc=ATTRBLASON;
  SINON
     AttrFenPrinc=ATTRARBRE;
  FIN_SI
  fenetre=_wincreate(1,2,80,25,SIMPLE,AttrFenPrinc,AttrFenPrinc,
		    "",ATTRTITLE);
  _winselect(fenetre);

  InitBrevets();
  InitEleves();
  LectureConfig();

  memset(find,' ',LG_NOM_BREVET);
  find[LG_NOM_BREVET]='\0';

  COPIER(nomBarre,"");
  barreFonc=_helpbarcreate(nomBarre);
  posX=(X_AXETRONC-2)*8;posY=(Y_AXETRONC+1)*8;
  AllumeCurseurSouris();
  PositionnementCurseur(posX,posY+8);


  REPETER
    SI ReAffich==VRAI ALORS
       EteintCurseurSouris();

       _helpbardispose(barreFonc);
       _windispose(fenetre);

       SI idEnfant!=-1 ALORS
	  AttrFenPrinc=ATTRBLASON;
       SINON
	  AttrFenPrinc=ATTRARBRE;
       FIN_SI
       fenetre=_wincreate(1,2,80,25,SIMPLE,AttrFenPrinc,AttrFenPrinc,
		    "",ATTRTITLE);
       _winselect(fenetre);
       InitAffichage();
       AffichGraphisme(idEnfant,arbreClasse);

       COPIER(nomBarre,"");
       SI idEnfant!=-1 ALORS
	  SI L_TYPEACCES()==ACCES_INSTIT ALORS
	     sprintf(nomBarre,"<%d>%s(%d;%d) F3:Russi   Supp:Enlev    F12:Catgorie/Arbre",L_NIVEAUELEVE(idEnfant),L_SURNOMELEVE(idEnfant),NbBrevetsEnfant(idEnfant,FAUX),NbBrevetsEnfant(idEnfant,VRAI));
	  SINON
	     sprintf(nomBarre,"<%d>%s(%d;%d)   F7:Blason   F4:Aider   F9:Propositions de Bingo",L_NIVEAUELEVE(idEnfant),L_SURNOMELEVE(idEnfant),NbBrevetsEnfant(idEnfant,FAUX),NbBrevetsEnfant(idEnfant,VRAI));
	  FIN_SI
       SINON
	  SI L_TYPEACCES()==ACCES_INSTIT ALORS
	     sprintf(nomBarre," %s(%d) Supp:Enlever des russites   F3:Entrer des russites",L_NOM_INSTIT(),L_NBREUSSITES());
	  SINON
	     sprintf(nomBarre," ARBRE(%d)    F2:Chercher    F11:login    F12:Catg.    F10:Menu",L_NBREUSSITES());
	  FIN_SI
       FIN_SI

       barreFonc=_helpbarcreate(nomBarre);
       _helpbarshow(barreFonc);

       /* positionnement du curseur sur le brevet */
       SI idBrevet!=PAS_DE_BREVET ALORS
	  y=0;
	  TANTQUE y<25 FAIRE
	     x=0;
	     TANTQUE x<80 FAIRE
		SI idBrevet==L_TABAFFICH(x,y) ALORS
		   posX=(x-1)*8;posY=(y-2)*8;
		   PositionnementCurseur(posX,posY+8);
		FIN_SI
		x++;
	     FIN_TANTQUE
	     y++;
	  FIN_TANTQUE
       FIN_SI

       AllumeCurseurSouris();

       ReAffich=FAUX;
    FIN_SI

    ancPosX=posX;ancPosY=posY;
    PositionEtatSouris(&etatBouton,&posX,&posY);
    SI posX!=ancPosX OU posY!=ancPosY ALORS
       x=(posX/8)+1;
       y=(posY/8)+1;
       idBrevet=L_TABAFFICH(x,y);
       AffichInfoBrevet(idBrevet,idEnfant);
    FIN_SI

    SI kbhit() ALORS
       c=_kbdread();
    FIN_SI

    LORSQUE c VAUT
      SOIT F1  : c=0;
		 SI idEnfant>=0 ALORS
		    _helpdisplay(3);
		 SINON
		    _helpdisplay(2);
		 FIN_SI
		 FIN_SOIT
      SOIT AF4 : c=0;
		 sortie=VRAI;
		 LanceMenu=FAUX;
		 FIN_SOIT
      SOIT ESC : c=0;
		 SI L_TYPEACCES()!=ACCES_NON_INIT ET
		    L_TYPEACCES()!=ACCES_INSTIT ALORS
		    AuRevoir();
		    idEnfant=-1;
		    clef=GEST_ARBRE;
		    SI L_TYPEACCES()!=ACCES_INSTIT ALORS
		       E_TYPEACCES(ACCES_NON_INIT);
		    FIN_SI
		    InitBrevets();
		    InitEleves();
		    ReAffich=VRAI;
		 FIN_SI
		 FIN_SOIT;

      SOIT DOWN : c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX,posY+8);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y);
		  FIN_SOIT
      SOIT UP   : c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX,posY-8);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y);
		  FIN_SOIT
      SOIT RIGHT: c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX+8,posY);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y);
		  FIN_SOIT
      SOIT LEFT : c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX-8,posY);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y);
		  FIN_SOIT



      SOIT F2 : SI premierPassage==VRAI ALORS
		   premierPassage=FAUX;
		SINON
		   premierPassage=VRAI;
		   c=0;
		   RechercherBrevet(&xTrouve,&yTrouve,find,idEnfant);
		   posX=(xTrouve-1)*8;posY=(yTrouve-2)*8;
		   PositionnementCurseur(posX,posY+8);
		FIN_SI
		FIN_SOIT

      SOIT F3 :
		InitBrevets();
		InitEleves();
		type=REUSSI;
		c=0;
		SI L_TYPEACCES()==ACCES_INSTIT ALORS
		   SI idBrevet!=PAS_DE_BREVET ALORS
		      AffectUnBrevet(idBrevet,type);
		   SINON
		      AffectBrevets(type);
		   FIN_SI
		   ReAffich=VRAI;
		FIN_SI
		FIN_SOIT

      SOIT DEL :
		InitBrevets();
		InitEleves();
		c=0;
		SI L_TYPEACCES()==ACCES_INSTIT ALORS
		   SI idBrevet!=PAS_DE_BREVET ALORS
		      DesaffectUnBrevet(idBrevet);
		      ReAffich=VRAI;
		   FIN_SI
		FIN_SI
		FIN_SOIT

      SOIT F5 : c=0;
		EcrireA(0);
		ReAffich=VRAI;
		FIN_SOIT

      SOIT F6  : c=0;
		 EcrireA(1);
		 ReAffich=VRAI;
		 FIN_SOIT

      SOIT F7   :  /* affichage du blason */
		   c=0;
		   Imprimer(FAUX);
		   FIN_SOIT

      SOIT F4   :  c=0;
		   SI idEnfant>=0 ALORS
		      InitBrevets();
		      InitEleves();
		      QuiJePeuxAider(idEnfant);
		   FIN_SI
		   ReAffich=VRAI;
		   FIN_SOIT

      SOIT 'o'  :
      SOIT 'O'  :   c=0;
		   SI L_ORDRE()==ORDRE_CHRONO ALORS
		      E_ORDRE(ORDRE_DETENTEURS);
                   SINON
		      E_ORDRE(ORDRE_CHRONO);
		   FIN_SI
		   ReAffich=VRAI;
		   FIN_SOIT
       SOIT 'M' :
       SOIT 'm' :  c=0;
		   InitBrevets();
		   InitEleves();
		   SI idBrevet!=PAS_DE_BREVET ALORS
		      ModifierBrevet(MODIFIER+10*idBrevet);
		   SINON
		      ModifierBrevet(NOUVEAU);
		   FIN_SI
		   ReAffich=VRAI;
		   FIN_SOIT;
       SOIT 'I' :
       SOIT 'i' :  c=0;
		   SI idEnfant!=-1 ALORS
		      PropositionDeBingoPour(idEnfant,VRAI);
		   FIN_SI
		   FIN_SOIT;
       SOIT F9 :   c=0;
		   SI idEnfant!=-1 ALORS
		      PropositionDeBingoPour(idEnfant,FAUX);
		   FIN_SI
		   FIN_SOIT;
       SOIT F10 :   c=0;
		   sortie=VRAI;
		   SI L_TYPEACCES()!=ACCES_INSTIT ALORS
		      AuRevoir();
		   FIN_SI
		   LanceMenu=VRAI;
		   AffichBandeau();
		   FIN_SOIT
       SOIT F11 :  c=0;
		   idEnfant=SelectEnfant(VRAI,NON_INIT,15,"Ton prnom");
		   SI idEnfant>=0 ALORS
		      SI L_TYPEACCES()!=ACCES_INSTIT ALORS
			 E_TYPEACCES(idEnfant);
			 VoirMaBoite(idEnfant);
		      FIN_SI
		   FIN_SI
		   ReAffich=VRAI;
		   FIN_SOIT;
	SOIT CF11 :  c=0;
		    SI L_TYPEACCES()!=ACCES_INSTIT ALORS
		       SI CodeInstit()==VRAI ALORS
			  Nouvelles(0);
		       FIN_SI
		    SINON
		       AuRevoir();
		       idEnfant=-1;
		    FIN_SI
		    ReAffich=VRAI;
		    FIN_SOIT
       SOIT F12 :  c=0;
		   SI L_MODECAT()==MODE_CATEGORIE ALORS
		      E_MODECAT(MODE_SANS_CATEGORIE);
		   SINON
		      E_MODECAT(MODE_CATEGORIE);
		   FIN_SI
		   ReAffich=VRAI;
		   FIN_SOIT

       SOIT CR :   c=0;
		   SI idBrevet!=PAS_DE_BREVET ALORS
		      InitBrevets();
		      InitEleves();
		      SI DetenteursBrevet(idBrevet,L_MODECAT())==VRAI ALORS
			 ReAffich=VRAI;
		      FIN_SI
		      c=0;
		   FIN_SI
		   FIN_SOIT
       SOIT SF1 :  AffichePalette();
		   c=0;
		   ReAffich=VRAI;
		   FIN_SOIT
       SOIT '<' :  c=0;
		   LargeurTronc--;
		   LargeurTronc=max(3,LargeurTronc);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT
       SOIT '>' :  c=0;
		   LargeurTronc++;
		   LargeurTronc=min(9,LargeurTronc);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT
       SOIT 'J' :
       SOIT 'j' :  c=0;
		   LongueurBranche++;
		   LongueurBranche=min(9,LongueurBranche);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT
       SOIT 'F' :
       SOIT 'f' :  c=0;
		   LongueurBranche--;
		   LongueurBranche=max(3,LongueurBranche);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT

       SOIT '+'  : c=0;
		   LongueurBranche=LongueurBranche++;
		   LongueurBranche=min(9,LongueurBranche);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT

       SOIT '-'  : c=0;
		   LongueurBranche=LongueurBranche--;
		   LongueurBranche=max(0,LongueurBranche);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT

       SOIT 'p'  :
       SOIT 'P'  : c=0;
		   SI L_TYPEACCES()!=ACCES_INSTIT ALORS
		      ChangeMotDePasse(idEnfant);
		      ReAffich=VRAI;
		   FIN_SI
		   FIN_SOIT
       SOIT 's'  :
       SOIT 'S'  : c=0;
		   InitBrevets();
		   InitEleves();
		   SI idBrevet!=PAS_DE_BREVET ALORS
		      SupprimerBrevet(idBrevet);
		   FIN_SI
		   InitBrevets();
		   InitEleves();
		   ReAffich=VRAI;
		   FIN_SOIT

       SOIT PGDN  : SI clef==GEST_TOUS OU clef==GEST_TOUS_ARBRE ALORS
		       c=0;
		       idEnfant++;
		       SI idEnfant>=L_NBELEVES() ALORS
			  idEnfant=0;
		       FIN_SI
		       ReAffich=VRAI;
		    FIN_SI
		    FIN_SOIT
       SOIT PGUP  : SI clef==GEST_TOUS OU clef==GEST_TOUS_ARBRE ALORS
		       c=0;
		       idEnfant--;
		       SI idEnfant<0 ALORS
			  idEnfant=L_NBELEVES()-1;
		       FIN_SI
		       ReAffich=VRAI;
		    FIN_SI
		    FIN_SOIT
    FIN_LORSQUE

  JUSQUA sortie==VRAI FIN_REPETER;

  EteintCurseurSouris();

  _helpbardispose(barreFonc);
  _windispose(fenetre);

fin
