#include "bingo.h"


/*--------------------------------------------*/
FONCTION int CalculReussites(void)
debut
  int nbReussites,i;

  i=0;nbReussites=0;
  TANTQUE i<L_NBELEVES() FAIRE
     nbReussites+=L_NBBREVETSELEV(i);
     i++;
  FIN_TANTQUE

  retour nbReussites;
fin

/*--------------------------------------------*/
FONCTION int NbReussitesCategorie(int idCat)
debut
  int nbReussites=0, idBrev, i,j;

  i=0;
  TANTQUE i<L_NBELEVES() FAIRE
     j=0;
     TANTQUE j<L_NBBREVETSELEV(i) FAIRE
	idBrev=abs(L_BREVELEV(i,j));
	SI L_IDCATEGORIE(idBrev)==idCat ALORS
	   nbReussites++;
	FIN_SI
	j++;
     FIN_TANTQUE
     i++;
  FIN_TANTQUE

  retour nbReussites;
fin

/*--------------------------------------------*/
FONCTION int CalculPourcentageCategorie(int idCat)
debut
  int pourcentage=0;
  float f_pourc;

  f_pourc=(NbReussitesCategorie(idCat)*100)/(float)((CalculReussites()));

  pourcentage=(int)(f_pourc);
  SI f_pourc>=pourcentage+0.5 ALORS
     pourcentage++;
  FIN_SI

  retour pourcentage;
fin

/*--------------------------------------------*/

FONCTION int CodageBinaire (int niveauEleve)
debut
  LORSQUE niveauEleve VAUT
     SOIT 1 : retour 1;
     SOIT 2 : retour 2;
     SOIT 3 : retour 4;
     SOIT 4 : retour 8;
     SOIT 5 : retour 16;
     SOIT 6 : retour 32;
     SOIT 7 : retour 64;
     SOIT 8 : retour 128;
     SOIT 9 : retour 256;
  FIN_LORSQUE

  retour 0;
fin

/*--------------------------------------------*/
FONCTION int SaisieMotCle(char *find)
debut
  windows *W_ChercheBrev;

  W_ChercheBrev=_wincreate(3,4,LG_RECHERCHE+6,9,
			SIMPLE,ATTRNORMAL,ATTRNORMAL,"Rechercher",ATTRTITLE);

  _winselect(W_ChercheBrev);
  _wingotoxy(1,4);_winputs("Saisissez 'AUTEUR' pour rechercher lesbrevets sans auteur");

  _getadd(3,2,STRING,find,0,"");
  _getread(NORMAL_MODE);
  _getdispose();
  COPIER(find,SuppEspaceFin(find));

  _windispose(W_ChercheBrev);

  SI find[0]!='\0' ALORS
     retour VRAI;
  SINON
     retour FAUX;
  FIN_SI

fin

/* ---------------------------------------- */

PROCEDURE AffichPTEnfant (int idEleve)
debut
  int car=GRAPH_PT_ENFANT;
  int couleur;
  int x,y,idBrevet,i;

  y=0;
  x=0;

  LectureDuPT(idEleve,NON_INIT);

  REPETER

    SI L_TABAFFICH(x,y)!=PAS_DE_BREVET ALORS
       idBrevet=L_TABAFFICH(x,y)%1000;
       i=0;
       TANTQUE i<NB_MAX_ITEM_PT FAIRE
	  SI idBrevet==PT[i] ALORS
	     couleur=L_TABAFFICH(x,y)/1000;
	     _winattr((COULEUR2<<4)+couleur);
	     _wingotoxy(x-1,y-2);
	     _winputc(car);
	  FIN_SI
	  i++;
       FIN_TANTQUE
    FIN_SI

    x++;
    SI x==80 ALORS
       x=0;
       y++;
    FIN_SI

  JUSQUA y==25 FIN_REPETER

fin

/*--------------------------------------------*/

FONCTION int RechercherBrevet (int xFin, int yFin, int *xTrouve, int *yTrouve, char *find)
debut
  int x,y,idBrevet, couleur;
  int car=GRAPH_RECHERCHE;
  int trouve=FAUX;
  char nomBrevMin[LG_TITRE_BREVET+1];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];

     y=*yTrouve;
     x=*xTrouve+1;

       REPETER

       SI L_TABAFFICH(x,y)!=PAS_DE_BREVET ALORS

	  idBrevet=L_TABAFFICH(x,y)%1000;
	  nomBrevMin[0]='\0';
	  comment1[0]='\0';
	  comment2[0]='\0';
	  LitInfosBrevet(idBrevet,nomBrevMin,comment1,comment2);

	  strlwr(nomBrevMin);
	  SI strstr(nomBrevMin,strlwr(find)) !=NULL OU
	     (strcmp(strupr(find),"AUTEUR")==0 ET L_IDAUTEUR(idBrevet)==AUCUN_AUTEUR) ALORS
	     couleur=L_TABAFFICH(x,y)/1000;
	     _wingotoxy(x-1,y-2);
	     _winattr((COULEUR2<<4)+couleur);
	     _winputc(car);
	     *xTrouve=x;*yTrouve=y;
	     trouve=VRAI;
	  FIN_SI
       FIN_SI
       x++;
       SI x==80 ALORS
	  x=0;
	  y++;
	  SI y==25 ALORS
	     y=0;
	  FIN_SI
       FIN_SI
     JUSQUA ((y==yFin ET x==xFin) OU trouve==VRAI ) FIN_REPETER

  retour trouve;

fin

/*--------------------------------------------*/

PROCEDURE far DesaffectUnBrevet(int idBrevet)
debut
  int idEnfant, cr;

/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

  SI idBrevet>0 ALORS
       TANTQUE (idEnfant=SelectEnfant(FAUX,idBrevet,"Qui ne sait plus faire ?")) >=0 FAIRE
	  /* desaffectation de brevet */
	  cr=EnfantABrevet(idEnfant,idBrevet);
	  SI cr!=0 ALORS
	     SuppBrevFicEnf(idEnfant,idBrevet,FAUX,ACCES_INSTIT);
	  SINON
	     Message(13,ATTRTITLE,idEnfant,"\n Brevet jamais obtenu !!\n\n");
	  FIN_SI
       FIN_TANTQUE
  FIN_SI
fin


/*-----------------------------------------------------------------------*/

PROCEDURE AffectUnBrevet(int idBrevet, int emetteur)
debut
  int idEnfant;

  TANTQUE (idEnfant=SelectEnfant(FAUX,idBrevet," Qui sait faire ?")) >=0 FAIRE
     /* ajout d'un brevet */
     SI AjouBrevFicEnf(idEnfant,idBrevet,FAUX,emetteur)==1 ALORS;
	Message(13,ATTRTITLE,idEnfant,"\n   Brevet dj obtenu !!\n\n");
     FIN_SI
  FIN_TANTQUE
fin

/*-----------------------------------------------------------------------*/
PROCEDURE FusionneDeuxBrevets(int idBrevet1, int idBrevet2)
debut
  int idEnfant;
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet1[LG_TITRE_BREVET+1];
  char nomBrevet2[LG_TITRE_BREVET+1];
  windows *W_fen;
  int cr;

  W_fen=_wincreate(9,2,LG_TITRE_BREVET+5,11,
			SIMPLE,ATTRNORMAL,ATTRNORMAL,"Fusionner deux brevets",ATTRTITLE);

  _winselect(W_fen);

  nomBrevet1[0]='\0';
  comment1[0]='\0';
  comment2[0]='\0';
  LitInfosBrevet(idBrevet1,nomBrevet1,comment1,comment2);

  nomBrevet2[0]='\0';
  comment1[0]='\0';
  comment2[0]='\0';
  LitInfosBrevet(idBrevet2,nomBrevet2,comment1,comment2);

  _winprintf("\n Suppression du brevet : \n - %s\n\n Fusion dans le brevet : \n - %s",nomBrevet1,nomBrevet2);


  _getadd_button(15,8," OUI ",VRAI,ON, 1,0,"Validation de la fusion");
  _getadd_button(40,8," NON ",FAUX,ON, 1,0,"Abandon de la fusion");


   cr=_getread(NORMAL_MODE);
   _getdispose();

   SI cr==VRAI ALORS

     ArchiveChangement(-1,idBrevet2,L_TYPEACCES(),"F ");

     idEnfant=0;
     TANTQUE idEnfant<L_NBELEVES() FAIRE
	SI EnfantABrevet(idEnfant,idBrevet1)==1 ALORS
	   AjouBrevFicEnf(idEnfant,idBrevet2,FAUX,L_TYPEACCES());
	FIN_SI
	idEnfant++;
     FIN_TANTQUE

     SupprimerBrevet(idBrevet1,FAUX,-1);

     _windispose(W_fen);

     Message(13,ATTRTITLE,NON_INIT,"\n\n\n\n                       Fusion russie !");
  SINON
     _windispose(W_fen);
  FIN_SI

fin

/*-----------------------------------------------------------------------*/

PROCEDURE ClasseParOrdreAlpha(int tab[], int categ)
debut
  int idBrev, idBrevTrie, catBrev,idCat;
  int tampon;
  char nomBrevetPrec[LG_TITRE_BREVET+1], nomBrevetSuiv[LG_TITRE_BREVET+1];
  int change;
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];

  idBrev=1;
  TANTQUE idBrev<=L_NBBREVETS() FAIRE
     brevetsClasses[idBrev]=idBrev;
     idBrev++;
  FIN_TANTQUE

  idBrevTrie=0;
  change=VRAI;
  TANTQUE change==VRAI FAIRE
     change=FAUX;
     idBrev=2;
     TANTQUE idBrev<=L_NBBREVETS() FAIRE

	nomBrevetPrec[0]='\0';
	comment1[0]='\0';
	comment2[0]='\0';
	LitInfosBrevet(brevetsClasses[idBrev-1],nomBrevetPrec,comment1,comment2);

	nomBrevetSuiv[0]='\0';
	comment1[0]='\0';
	comment2[0]='\0';
	LitInfosBrevet(brevetsClasses[idBrev],nomBrevetSuiv,comment1,comment2);

        SI strcmp(nomBrevetSuiv,nomBrevetPrec)<0 ALORS
	   tampon=brevetsClasses[idBrev-1];
	   brevetsClasses[idBrev-1]=brevetsClasses[idBrev];
	   brevetsClasses[idBrev]=tampon;
	   change=VRAI;
        FIN_SI
        idBrev++;
     FIN_TANTQUE
  FIN_TANTQUE

  SI categ==MODE_SANS_CATEGORIE ALORS
     idBrev=1;
     TANTQUE idBrev<=L_NBBREVETS() FAIRE
	tab[idBrev]=brevetsClasses[idBrev];
	idBrev++;
     FIN_TANTQUE
     retour;
  FIN_SI

  idBrevTrie=1;
  idCat=-1;
  TANTQUE idCat<NB_MAX_CATEGORIE FAIRE
     idBrev=1;
     TANTQUE idBrev<=L_NBBREVETS() FAIRE
	catBrev=L_IDCATEGORIE(brevetsClasses[idBrev]);
        SI catBrev==idCat ALORS
	   tab[idBrevTrie]=brevetsClasses[idBrev];
           idBrevTrie++;
        FIN_SI
        idBrev++;
     FIN_TANTQUE
     idCat++;
  FIN_TANTQUE
fin

/*--------------------------------------------*/
PROCEDURE ClasseParNbDetenteurs(int tab[])
debut
  int idBrev, idBrevTrie, j;

  /* classement via nombre de dtenteurs */
  idBrevTrie=1;
  j=L_NBELEVES();
  TANTQUE j>=0 FAIRE
     idBrev=1;
     TANTQUE idBrev<=L_NBBREVETS() FAIRE
	SI L_NBDETENTEURS(idBrev)==j ALORS
	   tab[idBrevTrie]=idBrev;
           idBrevTrie++;
        FIN_SI
        idBrev++;
     FIN_TANTQUE
     j--;
  FIN_TANTQUE

fin

/*--------------------------------------------*/

PROCEDURE ClasseParCategorieEtNbDetenteurs(int tab[])
debut
  int idBrev, idBrevTrie, j, idCat, catBrev;

  /* classement pralable Nombre de dtenteurs */
  idBrevTrie=1;
  j=L_NBELEVES();
  TANTQUE j>=0 FAIRE
     idBrev=1;
     TANTQUE idBrev<=L_NBBREVETS() FAIRE
	SI L_NBDETENTEURS(idBrev)==j ALORS
	   brevetsClasses[idBrevTrie]=idBrev;
           idBrevTrie++;
        FIN_SI
        idBrev++;
     FIN_TANTQUE
     j--;
  FIN_TANTQUE

  /* classement par categorie */
  idBrevTrie=1;
  idCat=-1;
  TANTQUE idCat<NB_MAX_CATEGORIE FAIRE
     idBrev=1;
     TANTQUE idBrev<=L_NBBREVETS() FAIRE
	catBrev=L_IDCATEGORIE(brevetsClasses[idBrev]);
        SI catBrev==idCat ALORS
	   tab[idBrevTrie]=brevetsClasses[idBrev];
           idBrevTrie++;
        FIN_SI
        idBrev++;
     FIN_TANTQUE
     idCat++;
  FIN_TANTQUE

fin

/*--------------------------------------------*/
PROCEDURE ClasseParOrdreAcquisition(int tab[])
debut
  int iemeBrevElev,idEnfant,idBrev,idRech,v,idMemo;

  /* Initialisation du tableau pyramide */
  idBrev=0;
  TANTQUE idBrev<=L_NBBREVETS() FAIRE
     valBrevet[idBrev]=0;
     idBrev++;
  FIN_TANTQUE

  /* Affectation d'un nombre de points par brevet en fonction des ordres */
  /* de son acquisition dans chaque blason */
  idEnfant=L_NBELEVES()-1;
  TANTQUE idEnfant>=0 FAIRE
     iemeBrevElev=1;
     TANTQUE iemeBrevElev<=L_NBBREVETSELEV(idEnfant) FAIRE
	SI L_BREVELEV(idEnfant,iemeBrevElev)>0 ALORS
	   valBrevet[L_BREVELEV(idEnfant,iemeBrevElev)]+=iemeBrevElev;
	FIN_SI
	iemeBrevElev++;
     FIN_TANTQUE
     idEnfant--;
  FIN_TANTQUE

  /* Moyenne en fonction du nombre de detenteurs */
  idBrev=1;
  TANTQUE idBrev<=L_NBBREVETS() FAIRE
     SI L_NBDETENTEURS(idBrev)!=0 ALORS
	valBrevet[idBrev]=((valBrevet[idBrev]/L_NBDETENTEURS(idBrev))*L_NBELEVES())/L_NBDETENTEURS(idBrev);
     FIN_SI
     idBrev++;
  FIN_TANTQUE

  /* Affectation d'un gros coeff des brevets avec aucun dtenteurs */
  /* pour qu'ils soient en fin de liste */
  idBrev=0;
  TANTQUE idBrev<=NB_MAX_BREVETS FAIRE
     SI valBrevet[idBrev]==0 ALORS
	valBrevet[idBrev]=L_NBBREVETS()*L_NBELEVES();
     FIN_SI
     idBrev++;
  FIN_TANTQUE

  /* Tri dans le tableau Tab */
  v=L_NBBREVETS()*L_NBELEVES();
  idBrev=1;
  TANTQUE idBrev<=L_NBBREVETS() FAIRE
     /* Recherche du n ieme plus petit */
     idRech=1;idMemo=-1;
     TANTQUE idRech<=L_NBBREVETS() FAIRE
	SI valBrevet[idRech]>=0 ET valBrevet[idRech]<=v ALORS
	   idMemo=idRech;
	   v=valBrevet[idRech];
	FIN_SI
	idRech++;
     FIN_TANTQUE
     SI idMemo>0 ALORS
	tab[idBrev]=idMemo;
	valBrevet[idMemo]=-1;
	v=L_NBBREVETS()*L_NBELEVES();
     SINON
	SyntaxeErreur(ID_CODE,"ClasseparOrdreAcquisition",idBrev);
	getch();
     FIN_SI
     idBrev++;
  FIN_TANTQUE

fin

/*--------------------------------------------*/

FONCTION int Ressemblance(int id1, int idRef)
debut
  int i, j,k;
  int trouve=FAUX;

  i=0;
  /* boucle sur les lves */
  TANTQUE i<L_NBELEVES() FAIRE
     j=1;
     trouve=FAUX;
     /* boucle sur les brevets de l'lve */
     TANTQUE j<=L_NBBREVETSELEV(i) ET PAS trouve FAIRE

	SI L_BREVELEV(i,j) == id1 ALORS

	   k=1;
	   TANTQUE k<=L_NBBREVETSELEV(i) ET PAS trouve FAIRE
	      SI L_BREVELEV(i,k) == idRef ALORS
		 trouve=VRAI;
	      FIN_SI
	      k++;
	   FIN_TANTQUE
	   SI trouve==FAUX ALORS
	      retour 0;
	   FIN_SI
        FIN_SI
	j++;
     FIN_TANTQUE
     i++;
  FIN_TANTQUE

  retour 100;

fin


/*--------------------------------------------*/

FONCTION int RessemblanceOld(int id1, int idRef)
debut
  int nbElements, compteur=0, idAChercher, i, j;
  int trouve=FAUX;

  /* nbElement = nombre de detenteurs du brevet le moins partage */
  SI L_NBDETENTEURS(id1)<=L_NBDETENTEURS(idRef) ALORS
     nbElements=L_NBDETENTEURS(id1);
  SINON
     nbElements=L_NBDETENTEURS(idRef);
  FIN_SI

  i=0;
  /* boucle sur les lves */
  TANTQUE i<L_NBELEVES() FAIRE
     j=1;
     trouve=FAUX;
     /* boucle sur les brevets de l'lve */
     TANTQUE j<=L_NBBREVETSELEV(i) ET PAS trouve FAIRE

	SI L_BREVELEV(i,j) == id1 OU L_BREVELEV(i,j) == idRef ALORS
	   SI L_BREVELEV(i,j) == id1 ALORS
	      idAChercher=idRef;
	   SINON
	      idAChercher=id1;
	   FIN_SI
	   TANTQUE j<=L_NBBREVETSELEV(i) ET PAS trouve FAIRE
	      SI L_BREVELEV(i,j) == idAChercher ALORS
		 trouve=VRAI;
		 compteur=compteur+1;
	      FIN_SI
	      j++;
	   FIN_TANTQUE
        FIN_SI
	j++;
     FIN_TANTQUE
     i++;
  FIN_TANTQUE

  retour compteur*100/nbElements;

fin

/*--------------------------------------------*/

/*FONCTION int CouleurBrevet(int couleur, int brevet, int eleve, int coulCat)
debut
  int catBrev;

   SI coulCat==VRAI ALORS
      catBrev=L_IDCATEGORIE(brevet);
      LORSQUE catBrev VAUT
	SOIT 0 :
	SOIT -1 :couleur=COULEUR15;FIN_SOIT
	SOIT 1 : couleur=COULEUR14;FIN_SOIT
	SOIT 2 : couleur=COULEUR13;FIN_SOIT
	SOIT 3 : couleur=COULEUR12;FIN_SOIT
	SOIT 4 : couleur=COULEUR11;FIN_SOIT
	SOIT 5 : couleur=COULEUR10;FIN_SOIT
	SOIT 6 : couleur=COULEUR9;FIN_SOIT
	SOIT 7 : couleur=COULEUR8;FIN_SOIT
	SOIT 8 : couleur=COULEUR7;FIN_SOIT
	SOIT 9 : couleur=COULEUR6;FIN_SOIT
	SOIT 10 : couleur=COULEUR5;FIN_SOIT
	SOIT 11 : couleur=COULEUR4;FIN_SOIT
	SOIT 12 : couleur=COULEUR3;FIN_SOIT
	SOIT 13 : couleur=COULEUR2;FIN_SOIT

      FIN_LORSQUE
  FIN_SI

  SI eleve>=0 ALORS
     SI EnfantABrevet(eleve,brevet)!=1 ALORS
	couleur=COULEUR1;
     FIN_SI
  SINON
     SI L_NBDETENTEURS(brevet)==0 ALORS
	couleur=COULEUR0;
     FIN_SI
  FIN_SI

  SI BrevetEstDansPT(brevet)==VRAI ALORS
     couleur=COULEUR3;
  FIN_SI

  retour couleur;
fin */

/*--------------------------------------------*/

/*PROCEDURE DecodeNiveau(int niveau, char *decod)
debut
  COPIER(decod,"000000000");

  SI (niveau&1)!=0 ALORS decod[0]='1'; FIN_SI
  SI (niveau&2)!=0 ALORS decod[1]='1'; FIN_SI
  SI (niveau&4)!=0 ALORS decod[2]='1'; FIN_SI
  SI (niveau&8)!=0 ALORS decod[3]='1'; FIN_SI
  SI (niveau&16)!=0 ALORS decod[4]='1';FIN_SI
  SI (niveau&32)!=0 ALORS decod[5]='1';FIN_SI
  SI (niveau&64)!=0 ALORS decod[6]='1';FIN_SI
  SI (niveau&128)!=0 ALORS decod[7]='1';FIN_SI
  SI (niveau&256)!=0 ALORS decod[8]='1';FIN_SI

fin*/

/* ---------------------------------- */

/*PROCEDURE AffBrevetATravailler(int clef, int idBrevet, FILE *ptImp,int type)*/
/* type = 1 : "brevets importants" choisis par l'instit
   type = 2 : "objectifs" choisis par l'instit ou l'enfant */
/*debut
  char prefixe;
  char nomLst[LG_TITRE_BREVET+3];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet[LG_TITRE_BREVET+1];

  nomBrevet[0]='\0';
  comment1[0]='\0';
  comment2[0]='\0';
  LitInfosBrevet(idBrevet,nomBrevet,comment1,comment2);

  SI type==1 ALORS
     prefixe='*';
  SINON
     prefixe='-';
  FIN_SI

  LORSQUE clef VAUT
     SOIT AFFICH : sprintf(nomLst,"%c %s",prefixe,nomBrevet);
		   _choiceadd(nomLst);
		   FIN_SOIT
     SOIT IMPRIM : SI ptImp!=NULL ALORS
		      SI L_IDCATEGORIE(idBrevet)!=AUCUNE_CATEGORIE ALORS
			 fprintf(ptImp,"%c %s\n",prefixe,nomBrevet);
		      SINON
			 fprintf(ptImp,"%c %s(%s)\n",prefixe,nomBrevet,Categorie[L_IDCATEGORIE(idBrevet)].Libelle);
		      FIN_SI
		   FIN_SI
		   FIN_SOIT
  FIN_LORSQUE
fin     */

/* ----------------------- */

PROCEDURE ListesBrevets(void)
debut
  FILE *ptLst,*ptLstCateg;
  int i,idBrev,idCat,idCatAnc=99;
  char chDate[30];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet[LG_TITRE_BREVET+1];

/*  SI TestBD(FAUX) == NOK ALORS
     retour;
  FIN_SI*/

  InitBrevets();
  InitEleves();

  AffichDate(chDate);

  /* ******************* */
  /* Liste par catgorie */
  /* ******************* */

  ClasseParOrdreAlpha(brevetsClasses,MODE_CATEGORIE);
  ptLstCateg=fopen("brevcat.txt","wt");
  SI ptLstCateg==NULL ALORS
     SyntaxeErreur(ID_SEFE,"brevcat.txt",0);
     retour;
  FIN_SI

  fprintf(ptLstCateg,"LES BREVETS CLASSES PAR CATEGORIE\n\n%s\n\n",chDate);
  fprintf(ptLstCateg,"Numro\tTitre\n\n");

  i=1;
  TANTQUE i<=L_NBBREVETS() FAIRE
     idBrev=brevetsClasses[i];

     nomBrevet[0]='\0';
     comment1[0]='\0';
     comment2[0]='\0';
     LitInfosBrevet(idBrev,nomBrevet,comment1,comment2);

     idCat=L_IDCATEGORIE(idBrev);
     SI idCat!=idCatAnc ET idCat!=AUCUNE_CATEGORIE ALORS
	fprintf(ptLstCateg,"\n%s\n",Categorie[idCat].Libelle);
	idCatAnc=idCat;
     SINON
	SI idCat!=idCatAnc ALORS
	   fprintf(ptLstCateg,"Sans catgorie\n");
	   idCatAnc=idCat;
	FIN_SI
     FIN_SI

     fprintf(ptLstCateg,"%d\t%s\n",i,nomBrevet);
     i++;
  FIN_TANTQUE
  fclose(ptLstCateg);

  /* *************************** */
  /* Liste par ordre aphabtique */
  /* *************************** */

  ClasseParOrdreAlpha(brevetsClasses,MODE_SANS_CATEGORIE);
  ptLst=fopen("brevalph.txt","wt");
  SI ptLst==NULL ALORS
     SyntaxeErreur(ID_SEFE,"brevalph.txt",0);
     retour;
  FIN_SI

  fprintf(ptLst,"LES BREVETS DANS L'ORDRE ALPHABETIQUE\n\n%s\n\n",chDate);
  fprintf(ptLst,"Numro\tTitre\n\n");
  i=1;
  TANTQUE i<=L_NBBREVETS() FAIRE
     idBrev=brevetsClasses[i];

     nomBrevet[0]='\0';
     comment1[0]='\0';
     comment2[0]='\0';
     LitInfosBrevet(idBrev,nomBrevet,comment1,comment2);

     idCat=L_IDCATEGORIE(idBrev);
     SI idCat!=AUCUNE_CATEGORIE ALORS
	fprintf(ptLst,"%d\t%s ****> %s\n",i,nomBrevet,Categorie[idCat].Libelle);
     SINON
	fprintf(ptLst,"%d\t%s\n",i,nomBrevet);
     FIN_SI
     i++;
  FIN_TANTQUE
  fclose(ptLst);

  /* *************************** */
  /* Liste par ordre de cration */
  /* *************************** */

  ptLst=fopen("brevcrea.txt","wt");
  SI ptLst==NULL ALORS
     SyntaxeErreur(ID_SEFE,"brevcrea.txt",0);
     retour;
  FIN_SI

  fprintf(ptLst,"LES BREVETS DANS L'ORDRE DE CREATION\n\n%s\n\n",chDate);
  fprintf(ptLst,"Numro\tTitre\n\n");

  idBrev=1;
  TANTQUE idBrev<=L_NBBREVETS() FAIRE

     nomBrevet[0]='\0';
     comment1[0]='\0';
     comment2[0]='\0';
     LitInfosBrevet(idBrev,nomBrevet,comment1,comment2);

     idCat=L_IDCATEGORIE(idBrev);
     SI idCat!=AUCUNE_CATEGORIE ALORS
	fprintf(ptLst,"%d\t%s ****> %s\n",idBrev,nomBrevet,Categorie[idCat].Libelle);
     SINON
	fprintf(ptLst,"%d\t%s\n",idBrev,nomBrevet);
     FIN_SI
     idBrev++;
  FIN_TANTQUE
  fclose(ptLst);

fin


/* ------------------------------------------------------------------------ */
/*                                                                          */
/*               VISUALISATION OU IMPRESSION DU BLASON                      */
/*                                                                          */
/* ------------------------------------------------------------------------ */

FONCTION int ListeBrevetsEnfant(int idEnfantSel)

debut
  FILE *ptFic;
  char nomFic[LG_FIC_EXT+1];
  char espace[LG_TITRE_BREVET+1];
  char etat[4+1];
  int y=0,i,j,k,id,idEnf,nbBrevet,c=0, idDebut, idFin;
  windows *W_liste;
  char chDate[30];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet[LG_TITRE_BREVET+1];

  AffichDate(chDate);

  SI idEnfantSel==NON_INIT ALORS
     COPIER(nomFic,"blasons.txt");
     ptFic=fopen(nomFic,"wt");
     SI ptFic==NULL ALORS
	SyntaxeErreur(ID_SEFE,"blasons.txt",0);
	retour 0;
     FIN_SI
  SINON
     sprintf(espace,"Liste des brevets de %s",L_SURNOMELEVE(idEnfantSel));
     W_liste=_wincreate(X1_AFF_BREVETS,Y1_AFF_BREVETS,
			DX_AFF_BREVETS,DY_AFF_BREVETS,
			SIMPLE,ATTRNORMAL,ATTRNORMAL,
			espace,ATTRTITLE);

     _winselect (W_liste);
     _winclrscr();
  FIN_SI

  SI idEnfantSel==NON_INIT ALORS
     idDebut=0;
     idFin=L_NBELEVES();
  SINON
     idDebut=idEnfantSel;
     idFin=idEnfantSel+1;
  FIN_SI

  idEnf=idDebut;
  TANTQUE idEnf<idFin FAIRE

     SI idEnfantSel==NON_INIT ALORS
	fprintf(ptFic,"%s %s\n\n\n\n",L_PRENOMELEVE(idEnf),L_NOMELEVE(idEnf));
	fprintf(ptFic,"%s\n\n",chDate);
     FIN_SI

     id=L_NBBREVETSELEV(idEnf);
     nbBrevet=0;
     TANTQUE id>=1 FAIRE
	SI L_BREVELEV(idEnf,id)>=0 ALORS
	   nbBrevet++;
	FIN_SI
	id--;
     FIN_TANTQUE

     id=L_NBBREVETSELEV(idEnf);
     TANTQUE id>=1 FAIRE
       i=L_BREVELEV(idEnf,id);
       SI i>=0 ALORS

	  nomBrevet[0]='\0';
	  comment1[0]='\0';
	  comment2[0]='\0';
	  LitInfosBrevet(i,nomBrevet,comment1,comment2);

	  j=strlen(nomBrevet);k=j;espace[0]='\0';
	  TANTQUE j<LG_TITRE_BREVET FAIRE
	     espace[j-k]=' ';
	     j++;
	  FIN_TANTQUE
	  espace[j-k]='\0';

	  sprintf(etat,"%3d ",nbBrevet);
	  nbBrevet--;

	  SI idEnfantSel==NON_INIT ALORS
	     fprintf(ptFic,"%s %s\n",etat,nomBrevet);
	  FIN_SI
	  SI idEnf==idEnfantSel ALORS
	     SI y>16 ALORS
		_winputs("\n       Appuyer sur une touche pour visualiser la suite");
		getch();
		_winclrscr();
		y=0;
	     FIN_SI
	     _winprintf(" %s  %s\n",etat,nomBrevet);
	     y++;
	  FIN_SI
       FIN_SI
       id--;
     FIN_TANTQUE

     SI idEnfantSel==NON_INIT ALORS
	fprintf(ptFic,"%c\n",12);
     FIN_SI

     idEnf++;
  FIN_TANTQUE

  SI idEnfantSel==NON_INIT ALORS
     fclose(ptFic);
  FIN_SI

  SI idEnfantSel>=0 ALORS
     c=getch();
     _windispose(W_liste);
  FIN_SI

  return c;
fin



/* ------------------------------------------------------------------------ */
/*                                                                          */
/*               IMPRESSION DU BLASON PAR CATEGORIE                         */
/*                                                                          */
/* ------------------------------------------------------------------------ */

FONCTION int CreerBlasCat(int idEnfantSel)
debut
  FILE *ptFic;
  char nomFic[LG_FIC_EXT+1];
  char espace[LG_TITRE_BREVET+1];
  int i,j,k,id,idEnf,c=0;
  char chDate[30];
  int idCat, premierBrevetDansCategorie;
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet[LG_TITRE_BREVET+1];

  /* preparation */

  AffichDate(chDate);

  COPIER(nomFic,"blascat.txt");

  ptFic=fopen(nomFic,"wt");
  SI ptFic==NULL ALORS
     SyntaxeErreur(ID_SEFE,"blascat.txt",0);
     retour 0;
  FIN_SI

  /* boucle sur les enfants */
  idEnf=0;
  TANTQUE idEnf<L_NBELEVES() FAIRE

     fprintf(ptFic,"%s %s\n\n\n\n",L_PRENOMELEVE(idEnf),L_NOMELEVE(idEnf));
     fprintf(ptFic,"%s\n\n",chDate);

     idCat=0;
     TANTQUE idCat < L_NBCATEGORIE() FAIRE
	premierBrevetDansCategorie=VRAI;
	id=L_NBBREVETSELEV(idEnf);

	TANTQUE id>=1 FAIRE

	   i=L_BREVELEV(idEnf,id);
	   SI i>=0 ET L_IDCATEGORIE(i)==idCat ALORS
	      SI premierBrevetDansCategorie==VRAI ALORS
		 premierBrevetDansCategorie=FAUX;
		 fprintf(ptFic,"\n***** %s *****\n",Categorie[idCat].Libelle);
	      FIN_SI

	      nomBrevet[0]='\0';
	      comment1[0]='\0';
	      comment2[0]='\0';
	      LitInfosBrevet(i,nomBrevet,comment1,comment2);

	      j=strlen(nomBrevet);k=j;espace[0]='\0';
	      TANTQUE j<LG_TITRE_BREVET FAIRE
		 espace[j-k]=' ';
		 j++;
	      FIN_TANTQUE
	      espace[j-k]='\0';

	      fprintf(ptFic," %s\n",nomBrevet);
	  FIN_SI
	  id--;

	FIN_TANTQUE

	idCat++;
     FIN_TANTQUE

/*     fprintf(ptFic,"%c\n",12);*/

     idEnf++;
  FIN_TANTQUE

  fclose(ptFic);

  SI idEnfantSel>=0 ALORS
     c=getch();
  FIN_SI

  return c;
fin



