#include "bingo.h"

/* *************************************************************** */

/*                  MENU  "moi"                                    */

/* *************************************************************** */

PROCEDURE ViderBoiteEnfant(int idEnfant)

debut
  char titre[80];
  char repertoire[LG_PATH+1];
  char nomFic[LG_FIC_EXT+1];
  FILE *ptFic;

  SI idEnfant<0 ALORS retour;
  FIN_SI

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  SI chdir("msg")!=0 ALORS   /* aucune boite n'a t cr */
     retour;
  FIN_SI

  COPIER(nomFic,L_NOMFIC(idEnfant));
  nomFic[strlen(nomFic)-4]='\0'; /* on supprime l'extension .txt */
  strcat(nomFic,".txt");

  unlink(nomFic);
  ptFic=fopen(nomFic,"wt");
  fclose(ptFic);

  sprintf(titre,"\n\n\n\n      La boite aux lettres de %s a t vide.",L_PRENOMELEVE(idEnfant));

  Message(13,ATTRTITLE,NON_INIT,titre);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

fin

/* ------------------------------------------------------------------ */

FONCTION int LireBoite(int idIndividu)
debut
  int c,y,i;
  char repertoire[LG_PATH+1];
  char ligne[LG_LIGNE];
  char nomFic[LG_FIC_EXT+1];
  FILE *ptFic;
  int courrier=FAUX;

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  SI chdir("msg")!=0 ALORS
     mkdir("msg");
     chdir("msg");
  FIN_SI

  SI L_TYPEACCES()==ACCES_INSTIT ALORS
     COPIER(nomFic,L_FIC_INSTIT());
  SINON
     COPIER(nomFic,L_NOMFIC(idIndividu));
     nomFic[strlen(nomFic)-4]='\0'; /* on supprime l'extension .txt */
  FIN_SI

  strcat(nomFic,".txt");

  i=1;
  SI (ptFic=fopen(nomFic,"rt"))!=NULL ALORS
     SI fgets(ligne,LG_LIGNE,ptFic)!=NULL ALORS
	y=3;
	_winattr(ATTRSELECT);
	SI L_TYPEACCES()==ACCES_INSTIT ALORS
	   _winprintf("        Bonjour le responsable, tu as du courrier !\n\n");
	SINON
	   _winprintf("        Bonjour %s, tu as du courrier !             \n\n",L_PRENOMELEVE(L_TYPEACCES()));
	FIN_SI
	_winattr(ATTRNORMAL);
	REPETER
	   SI y>17 ALORS
	      _winputs("\n               Appuyer sur une touche pour visualiser la suite");
	      getch();
	      _winclrscr();
	      y=0;
	   FIN_SI
	   SI i==1 ALORS
	      _winattr(ATTRSELECT);
	   SINON
	      _winattr(ATTRNORMAL);
	   FIN_SI
	   _winprintf("%s",ligne);
	   i++;
	   SI i==4 ALORS
	      i=1;
	   FIN_SI
	   y++;

	JUSQUA fgets(ligne,LG_LIGNE,ptFic)==NULL FIN_REPETER

	courrier=VRAI;
    FIN_SI
    fclose(ptFic);
  FIN_SI

  SI courrier==FAUX ALORS
     _winattr(ATTRSELECT);
     SI L_TYPEACCES()==ACCES_INSTIT ALORS
	_winprintf("  Bonjour le responsable, tu n'as pas reu de message pour l'instant !          \n");
     SINON
	_winprintf("  Bonjour %s, tu n'as pas reu de message pour l'instant !          \n",L_PRENOMELEVE(L_TYPEACCES()));
     FIN_SI
     _winattr(ATTRNORMAL);
  FIN_SI

  c=0;
  REPETER
    c=_kbdread();
  JUSQUA c!=0 FIN_REPETER

  L_REPCOURANT(repertoire);
  chdir(repertoire);

  LORSQUE c VAUT
     SOIT F5 : EcrireA(0);
	       FIN_SOIT
     SOIT F6 : EcrireA(1);
	       FIN_SOIT
  FIN_LORSQUE


  retour courrier;

fin

/* ------------------------------------------------------------------ */

PROCEDURE VoirMaBoite(int idEnfant)
debut
  windows *W_boite;
  char titre[80];
  char far *barreFonc=NULL;
  char nomBarre[80];
  int courrier;

  sprintf(titre,"Bote aux lettres de %s %s",L_PRENOMELEVE(idEnfant),L_NOMELEVE(idEnfant));

  W_boite=_wincreate(2,3,78,21,SIMPLE,ATTRNORMAL,ATTRBORDER,titre,ATTRTITLE);
  _winselect(W_boite);
  _winclrscr();

  sprintf(nomBarre," Envoyer un message  quelqu'un (F5), au responsable (F6)");
  barreFonc=_helpbarcreate(nomBarre);
  _helpbarshow(barreFonc);

  courrier=LireBoite(idEnfant);

  _helpbardispose(barreFonc);
  _windispose(W_boite);

  SI courrier==VRAI ALORS
     SI _mesdisplay("Veux-tu vider ta bote aux lettres ?")==VRAI ALORS
	ViderBoiteEnfant(idEnfant);
     FIN_SI
  FIN_SI

fin

/* ------------------------------------------------------------------ */

PROCEDURE far LoginInstit(int clef)
debut
  CodeInstit();
  GestEvts(GEST_ARBRE);
fin

PROCEDURE VoirBoiteInstit()
debut
  windows *W_boite;
  char titre[80];
  char far *barreFonc=NULL;
  char nomBarre[80];
  int courrier;

  sprintf(titre,"Bote aux lettres du responsable ");

  W_boite=_wincreate(2,3,78,21,SIMPLE,ATTRNORMAL,ATTRBORDER,titre,ATTRTITLE);
  _winselect(W_boite);
  _winclrscr();

  sprintf(nomBarre," Envoyer un message  quelqu'un (F5), au responsable (F6)");
  barreFonc=_helpbarcreate(nomBarre);
  _helpbarshow(barreFonc);

  courrier=LireBoite(-1);

  _helpbardispose(barreFonc);
  _windispose(W_boite);

  SI courrier==VRAI ALORS
     SI _mesdisplay("Veux-tu vider ta bote aux lettres ?")==VRAI ALORS
	ViderBoiteInstit();
     FIN_SI
  FIN_SI

fin


PROCEDURE ViderBoiteInstit()
debut
  char titre[80];
  char repertoire[LG_PATH+1];
  char nomFic[LG_FIC_EXT+1];
  FILE *ptFic;

  sprintf(titre,"Es-tu sur que tu veux vider la bote aux lettres du responsable ?");

  SI _mesdisplay(titre)==FALSE ALORS
     retour;
  FIN_SI

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  SI chdir("msg")!=0 ALORS   /* aucune boite n'a t cr */
     retour;
  FIN_SI

  COPIER(nomFic,L_FIC_INSTIT());
  strcat(nomFic,".txt");

  unlink(nomFic);
  ptFic=fopen(nomFic,"wt");
  fclose(ptFic);

  sprintf(titre,"\n\n\n\n      La boite aux lettres du responsable a t vide.");

  Message(13,ATTRTITLE,NON_INIT,titre);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

fin

/* ------------------------------------------------------------------ */

/*PROCEDURE AuRevoir()
debut
  char mess[80];

  SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
     SI L_TYPEACCES()==ACCES_INSTIT ALORS
	sprintf(mess,"\n A bientt %s !",L_NOM_INSTIT());
	Message(5,ATTRTITLE,NON_INIT,mess);
     SINON
	sprintf(mess,"\n A bientt %s !",L_PRENOMELEVE(L_TYPEACCES()));
	Message(5,ATTRNORMAL,L_TYPEACCES(),mess);
     FIN_SI
     AffichBandeau();
  FIN_SI

fin     */

/* ------------------------------------------------------------------ */



/* *************************************************************** */

/*                  MENU  "La classe"                              */

/* *************************************************************** */

PROCEDURE far MenuGroupesDeTravail(int clef)
debut
  GroupesDeTravail();
fin

PROCEDURE GroupesDeTravail()
debut
  FILE *ptLstGroupe;
  int i,c=0;
  char chDate[30];
  windows *W_groupe;
  int PTclasse[NB_MAX_ITEM_PT*NB_MAX_ELEVES+1];

  AffichDate(chDate);

  W_groupe=_wincreate(X1_AFF_BREVETS,Y1_AFF_BREVETS,
                   DX_AFF_BREVETS,DY_AFF_BREVETS,
                   SIMPLE,ATTRNORMAL,ATTRBORDER,
		   "Liste des projets",ATTRTITLE);
  _winselect(W_groupe);
  _winclrscr();
  _wingotoxy(1,2);

 ptLstGroupe=fopen("ecran.txt","wt");

  SI ptLstGroupe==NULL ALORS
     SyntaxeErreur(ID_SEFE,"ecran.txt",0);
     retour;
  FIN_SI

  fprintf(ptLstGroupe,"LISTE DES PROJETS\n\n%s\n\n",chDate);
  fprintf(ptLstGroupe,"\n\n");

  InitBrevets();
  InitEleves();
  LectureDesPTs();

  i=0;
  TANTQUE i<NB_MAX_ITEM_PT*L_NBELEVES() ALORS
     PTclasse[i]=PT[i];
     i++;
  FIN_TANTQUE

  i=0;
  TANTQUE i<NB_MAX_ITEM_PT*L_NBELEVES() ET PTclasse[i]!=NON_INIT FAIRE
     _winprintf("Projet n%d : \n-----------\n",i+1);
     fprintf(ptLstGroupe,"\n\nProjet n%d :\n-----------\n",i+1);
     InfosBrevet(PTclasse[i],VRAI,ptLstGroupe);
     c=0;
     REPETER
       c=_kbdread();
     JUSQUA c!=0 FIN_REPETER
     _winclrscr();
     _wingotoxy(1,2);
     i++;
  FIN_TANTQUE

  fclose(ptLstGroupe);

  _windispose(W_groupe);

fin

/* -------------------------------------------------------- */

PROCEDURE far Nouvelles (int clef)
debut
  FILE *ptFic;
  char chDate[30];
  char ligne[LG_LIGNE];
  windows *W_liste;
  int y=0;
  char repertoire[LG_PATH+1];
  int nbLgn=0;

  /* ouverture du fichier */
  AffichDate(chDate);

  L_REPDONNEES(repertoire);
  chdir(repertoire);
  ptFic=fopen(FIC_NOUVELLES,"rt");

     /* affichage */
     W_liste=_wincreate(X1_AFF_BREVETS,Y1_AFF_BREVETS,
			DX_AFF_BREVETS,DY_AFF_BREVETS,SIMPLE,ATTRNORMAL,ATTRBORDER,
			"Derniers changements dans l'arbre et les blasons",ATTRTITLE);
    _winselect (W_liste);
    _winclrscr();
    y=y+3;

    TANTQUE fgets(ligne,LG_LIGNE,ptFic)!=NULL FAIRE
       _winputs(ligne);
       y++;
       SI y>16 ALORS
	  _winputs("\n       Appuyer sur une touche pour visualiser la suite");
	  getch();
	  _winclrscr();
	  y=0;
       FIN_SI
       nbLgn++;
    FIN_TANTQUE

    getch();
    _windispose(W_liste);

  fclose(ptFic);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

  SI nbLgn>2 ALORS
     SI L_TYPEACCES()==ACCES_INSTIT ALORS
	SI _mesdisplay("Veux-tu effacer ?")==VRAI ALORS
	   ReInitDernieresReussites(VRAI);
	FIN_SI
     FIN_SI
  FIN_SI

fin


PROCEDURE InfosBrevet(int idBrevet, int ficOuvert, FILE *fImp)
debut
  int i, cpt, j, trouve, catBrev,premier, idAuteur;
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+1];
  char titre[160];
  char auteur[LG_SURNOM_ELEVE+1];
  char completTitre[160];

     comment1[0]='\0';comment2[0]='\0';
     LitInfosBrevet(idBrevet,titre,comment1,comment2);

     catBrev=L_IDCATEGORIE(idBrevet);
     SI catBrev!=AUCUNE_CATEGORIE ALORS
	sprintf(completTitre," => %s",Categorie[catBrev].Libelle);
	strcat(titre,completTitre);
     FIN_SI

     _winattr(ATTRSELECT);
     _winprintf("\n%s\n",titre);

     _winattr(ATTRNORMAL);
     idAuteur=L_IDAUTEUR(idBrevet);
     SI idAuteur>=0 ET idAuteur<L_NBELEVES() ALORS
	COPIER(auteur,L_SURNOMELEVE(idAuteur));
     SINON
	COPIER(auteur,"Aucun");
     FIN_SI
     _winprintf("Auteur : %s\n",auteur);

     _winprintf("%s\n%s\n",comment1,comment2);

     SI ficOuvert==VRAI ALORS
	fprintf(fImp,"\n%s\n",titre);
	fprintf(fImp,"Auteur : %s\n",auteur);
	fprintf(fImp,"%s\n%s\n",comment1,comment2);
     FIN_SI

     premier=VRAI;

     i=0;cpt=0;
     TANTQUE i<L_NBELEVES() FAIRE
	LectureDuPT(i,NON_INIT);
	SI BrevetEstDansPT(idBrevet)==VRAI ALORS

	   SI premier==VRAI ALORS
	      premier=FAUX;
	      _winattr(ATTRSELECT);
	      _winprintf("\nC'est un projet pour : \n");
	      SI ficOuvert==VRAI ALORS
		 fprintf(fImp,"\nC'est un projet pour :\n");
	      FIN_SI
	      _winattr(ATTRNORMAL);
	   FIN_SI

	   _winprintf("%15s ",L_SURNOMELEVE(i));
	   SI ficOuvert==VRAI ALORS
	      fprintf(fImp,"%15s ",L_SURNOMELEVE(i));
	   FIN_SI
	   cpt++;
	   SI cpt==3 ALORS
	      _winputs("\n");
	      cpt=0;
	   FIN_SI
	FIN_SI
	i++;
     FIN_TANTQUE

     /* les enfants qui peuvent aider */

     _winattr(ATTRSELECT);
     SI L_NBDETENTEURS(idBrevet)==1 ALORS
	_winprintf("\n\n1 enfant peut aider : ");
     SINON
	SI L_NBDETENTEURS(idBrevet)!=0 ALORS
	   _winprintf("\n\n%d enfants peuvent aider (%d%) : \n",L_NBDETENTEURS(idBrevet),L_NBDETENTEURS(idBrevet)*100/L_NBELEVES());
	   SI ficOuvert==VRAI ALORS
	      fprintf(fImp,"\n\n%d enfant(s) peut(peuvent) aider (%d) : \n",L_NBDETENTEURS(idBrevet),L_NBDETENTEURS(idBrevet)*100/L_NBELEVES());
	   FIN_SI
	FIN_SI
     FIN_SI

     _winattr(ATTRNORMAL);
     i=0;cpt=0;
     TANTQUE i<L_NBELEVES() FAIRE
	j=1;trouve=FAUX;
	TANTQUE j<=L_NBBREVETSELEV(i) ET PAS trouve FAIRE
	   SI L_BREVELEV(i,j) == idBrevet ALORS
	      _winprintf("%15s ",L_SURNOMELEVE(i));
	      SI j==L_NBBREVETSELEV(i) ALORS _winputs("*");
	      FIN_SI
	      SI ficOuvert==VRAI ALORS
		 fprintf(fImp,"%15s ",L_SURNOMELEVE(i));
		 SI j==L_NBBREVETSELEV(i) ALORS fprintf(fImp,"*");
		 FIN_SI
	      FIN_SI
	      cpt++;
	      SI cpt==3 ALORS
		 _winputs("\n");
		 cpt=0;
	      FIN_SI

	      trouve=VRAI;
	   FIN_SI
	   j++;
	FIN_TANTQUE
	i++;
     FIN_TANTQUE
     _winattr(ATTRNORMAL);
fin


/* ------------------------------------------------------------------ */

FONCTION int DetenteursBrevet(int idBrevet)
debut
  FILE *fImp;
  windows *W_brev;
  int c=0;
  int ficOuvert;
  char titre[160];
  char far *barreFonc=NULL;
  int idEnfant, selectEnfant;
  int ReAffich=FAUX;

  REPETER
     c=0;
     SI idBrevet>L_NBBREVETS() ALORS
	idBrevet=1;
     FIN_SI
     SI idBrevet<=0 ALORS idBrevet=L_NBBREVETS();
     FIN_SI
     SI (fImp=fopen("ecran.txt","wt"))!=NULL ALORS
	ficOuvert=VRAI;
     SINON
	ficOuvert=FAUX;
     FIN_SI

     W_brev=_wincreate(X1_AFF_BREVETS,Y1_AFF_BREVETS,
                   DX_AFF_BREVETS,DY_AFF_BREVETS,
                   SIMPLE,ATTRNORMAL,ATTRBORDER,
		   "BREVET ou PROJET",ATTRTITLE);
     _winselect(W_brev);
     _winclrscr();

     COPIER(titre,"");
     SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
	SI L_TYPEACCES()!=ACCES_INSTIT ALORS
	   sprintf(titre," F1: aide     F3: On sait     Supp: On ne sait plus     C: C'est mon projet");
	SINON
	   sprintf(titre," F1:aide    C:Inscrire...     F3:Donner le brevet  ...");
	FIN_SI
     FIN_SI

     barreFonc=_helpbarcreate(titre);
     _helpbarshow(barreFonc);

     InfosBrevet(idBrevet,ficOuvert, fImp);

     _winattr(ATTRNORMAL);

     SI ficOuvert==VRAI ALORS
	fclose(fImp);
     FIN_SI

     c=0;
     REPETER
       c=_kbdread();
     JUSQUA c!=0 FIN_REPETER

     _helpbardispose(barreFonc);
     _windispose(W_brev);

     LORSQUE c VAUT
      SOIT F1  : c=0;
		 SI L_TYPEACCES()==ACCES_INSTIT ALORS
		    _helpdisplay(7);
		 SINON
		    SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
		       _helpdisplay(8);
		    FIN_SI
		 FIN_SI
		 FIN_SOIT
	SOIT F5 : c=0;
		  SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
		     EcrireA(0);
		  FIN_SI
		  FIN_SOIT
	SOIT F6 : c=0;
		  SI L_TYPEACCES()!=ACCES_NON_INIT ALORS
		     EcrireA(1);
		  FIN_SI
		  FIN_SOIT

      SOIT F3 :
		c=0;
		SI idBrevet!=PAS_DE_BREVET ALORS
		   SI L_TYPEACCES()==ACCES_INSTIT OU L_TYPEACCES()==L_IDAUTEUR(idBrevet) ALORS
		      AffectUnBrevet(idBrevet,L_TYPEACCES());
		      ReAffich=VRAI;
		   SINON
		      SI L_TYPEACCES()!=ACCES_NON_INIT ET L_TYPEACCES()!=ACCES_INSTIT ALORS
			 idEnfant=L_TYPEACCES();
			 SI EnfantABrevet(idEnfant,idBrevet)<=0 ALORS
			    AjouBrevFicEnf(idEnfant, idBrevet, VRAI,idEnfant);
			    ReAffich=VRAI;
			 FIN_SI
		      FIN_SI
		   FIN_SI
		FIN_SI
		FIN_SOIT

      SOIT DEL :c=0;
		SI idBrevet!=PAS_DE_BREVET ALORS
		   SI L_TYPEACCES()==ACCES_INSTIT OU L_TYPEACCES()==L_IDAUTEUR(idBrevet) ALORS
		      DesaffectUnBrevet(idBrevet);
		      ReAffich=VRAI;
		   SINON
		      SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
			 idEnfant=L_TYPEACCES();
			 SI EnfantABrevet(idEnfant,idBrevet)>0 ALORS
			    SuppBrevFicEnf(idEnfant,idBrevet, VRAI,L_TYPEACCES());
			    ReAffich=VRAI;
			 FIN_SI
		      FIN_SI
		   FIN_SI
		FIN_SI
		FIN_SOIT

       SOIT F8  :  c=0;
		   SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
		      idEnfant=L_TYPEACCES();
		      EnvoiGroupe(idBrevet,idEnfant,VRAI);
		   FIN_SI
		   FIN_SOIT

	SOIT PGUP   : c=0;
		      idBrevet--;
		      FIN_SOIT
	SOIT PGDN   : c=0;
		      idBrevet++;
		      FIN_SOIT

/*       SOIT 't'   :
       SOIT 'T'   : c=0;
		   SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
		      idEnfant=L_TYPEACCES();
		      SI BrevetEstDansPT(idBrevet)==VRAI ALORS
			 SupprimeBrevetDansPT(idBrevet, idEnfant,L_TYPEACCES());
		      SINON
			 AjouteBrevetDansPT(idBrevet, idEnfant,L_TYPEACCES());
		      FIN_SI
		      ReAffich=VRAI;
		    FIN_SI
		    FIN_SOIT*/

       SOIT 'c'   :
       SOIT 'C'   : c=0;
		    SI idBrevet!=PAS_DE_BREVET
		       ET L_TYPEACCES()!=ACCES_NON_INIT ALORS

		       REPETER
			  SI L_TYPEACCES()==ACCES_INSTIT ALORS
			     selectEnfant=SelectEnfant(VRAI,idBrevet,"Inscrire qui ?");
			  SINON
			     selectEnfant=L_TYPEACCES();
			  FIN_SI

			  SI selectEnfant>=0 ALORS

			     SI EnfantABrevet(selectEnfant,idBrevet)==1 ALORS
				Message(7,ATTRTITLE,NON_INIT,"\n  Brevet dj russi !");
			     SINON
				/* ajout d'un projet */
				LectureDuPT(selectEnfant,NON_INIT);				LectureDuPT(selectEnfant,NON_INIT);
				TravailAjouteDansPT(idBrevet, selectEnfant, L_TYPEACCES());
			     FIN_SI
			  FIN_SI
			JUSQUA L_TYPEACCES()!=ACCES_INSTIT OU selectEnfant<0 FIN_REPETER
		       ReAffich=VRAI;
		    FIN_SI
		    FIN_SOIT

       SOIT 'x'   :
       SOIT 'X'   : c=0;
		    SI idBrevet!=PAS_DE_BREVET
		       ET L_TYPEACCES()!=ACCES_NON_INIT ALORS

		       REPETER
			 SI L_TYPEACCES()==ACCES_INSTIT ALORS
			    selectEnfant=SelectEnfant(VRAI,idBrevet,"Retir  qui ?");
			 SINON
			    selectEnfant=L_TYPEACCES();
			 FIN_SI

			 SI selectEnfant>=0 ALORS

			    LectureDuPT(selectEnfant,NON_INIT);

			    TravailEnleveDuPT(idBrevet, selectEnfant, L_TYPEACCES());
			 FIN_SI
		       JUSQUA L_TYPEACCES()!=ACCES_INSTIT OU selectEnfant<0 FIN_REPETER
		       ReAffich=VRAI;
		    FIN_SI
		    FIN_SOIT


     FIN_LORSQUE



  JUSQUA c==ESC FIN_REPETER

  retour ReAffich;

fin


/* *************************************************************** */

/*                  MENU  "instit"                                 */

/* *************************************************************** */

PROCEDURE far VoirTousArbres(int clef)
debut
/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

  SI CodeInstit()==VRAI ALORS
     GestEvts(GEST_TOUS);
  FIN_SI

fin

/* ------------------------------------------------------------------ */
PROCEDURE far VoirBlasonDansArbre(int clef)
debut
/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

  SI CodeInstit()==VRAI ALORS
     GestEvts(GEST_TOUS_ARBRE);
  FIN_SI

fin


/*----------------------------------------------------------------*/

PROCEDURE far ReInitDernieresReussites ()
debut
  FILE *ptFic;
  char chDate[30];
  char repertoire[LG_PATH+1];

  SI CodeInstit()==VRAI ALORS
     AffichDate(chDate);
     L_REPDONNEES(repertoire);
     chdir(repertoire);
     ptFic=fopen(FIC_NOUVELLES,"wt");
     fprintf(ptFic,"Les changements depuis le %s\n\n",chDate);
     fclose(ptFic);
     L_REPCOURANT(repertoire);
     chdir(repertoire);
  FIN_SI
fin

/*----------------------------------------------------------------*/

PROCEDURE far AffichTousBlasons()
debut
  int idEnfant,c;

/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

  SI CodeInstit()!=VRAI ALORS
     retour;
  FIN_SI

  InitBrevets();
  InitEleves();

  idEnfant=0;
  TANTQUE idEnfant<L_NBELEVES() ET kbhit()!=ESC FAIRE
     c=ListeBrevetsEnfant(idEnfant);
     SI c==ESC ALORS
	retour;
     FIN_SI
     idEnfant++;
  FIN_TANTQUE
fin


/*--------------------------------------------*/

PROCEDURE far ModifCategories()
debut
  windows *W_modifCat;
  char nomCat[NB_MAX_CATEGORIE][LG_CATEGORIE+1];
  int i,x,y;
  int modif=FAUX;

/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

  W_modifCat=_wincreate(7,3,69,20,
                        SIMPLE,ATTRNORMAL,ATTRBORDER,"Renommer les catgories",ATTRTITLE);
  _winselect (W_modifCat);

  LectureFicCat();

     i=0;
     TANTQUE i<NB_MAX_CATEGORIE FAIRE
        SI i<7 ALORS
           x=2;
           y=3+i*2;
        SINON
           x=35;
           y=3+(i-7)*2;
        FIN_SI
        _wingotoxy(x,y);_winprintf("Catgorie n%2d : ",i+1);
        COPIER(nomCat[i],Categorie[i].Libelle);
        _getadd(x+17,y,STRING,nomCat[i],0,"Modifier la catgorie : appuyer sur Entre pour valider");
        i++;
     FIN_TANTQUE

     _wingotoxy(25,18);_winputs("Ctrl F4 pour quitter !");

     _getread(DB_MODE);

     /* Modifications suite  la saisie */
     i=0;
     TANTQUE i<NB_MAX_CATEGORIE FAIRE
        SI strcmp(Categorie[i].Libelle,nomCat[i])!=0 ALORS
           modif=VRAI;
           COPIER(Categorie[i].Libelle,nomCat[i]);
        FIN_SI
	i++;
     FIN_TANTQUE

     SI modif==VRAI ALORS
        ModifFicCategorie();
        E_ACCEPTIMPORT(IMPORT_NOK);
     FIN_SI

     _windispose(W_modifCat);

fin

/* ------------------------------------------------------------------- */

PROCEDURE SupprimerBrevet(int idBrevetRef, int affFen, int emetteur)
debut
  int i, enf, nbBrevetsElev;
  char nomFic[12], nomFic2[12];
  char repertoire[LG_PATH+1];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet[LG_TITRE_BREVET+1];
  FILE *fp;

/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

  SI CodeInstit()!=VRAI ALORS
     retour;
  FIN_SI

  SI idBrevetRef<0 ALORS
     retour;
  FIN_SI

  SI affFen==VRAI ALORS

     DetenteursBrevet(idBrevetRef);

     SI _mesdisplay("Supprimer le brevet ?")==FALSE ALORS
	retour;
     FIN_SI

  FIN_SI

  ArchiveChangement(-1,idBrevetRef,emetteur,"BR -");

  nomBrevet[0]='\0';
  comment1[0]='\0';
  comment2[0]='\0';
  LitInfosBrevet(idBrevetRef,nomBrevet,comment1,comment2);

  /* suppression ventuelle du fichier d'informations du brevet */
  /* + renommage des autres fichiers */

  i=idBrevetRef;

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  itoa(i,nomFic,10);
  strcat(nomFic,".txt");
  unlink(nomFic);

  TANTQUE i<L_NBBREVETS() FAIRE
     itoa(i,nomFic,10);
     strcat(nomFic,".txt");
     itoa(i+1,nomFic2,10);
     strcat(nomFic2,".txt");
     rename(nomFic2,nomFic);
     /* ajout d'un espace pour que la date de modification change */
     fp=fopen(nomFic,"at");
     fputs(" ",fp);
     fclose(fp);
     i++;
  FIN_TANTQUE

  itoa(i,nomFic,10);
  strcat(nomFic,".txt");
  unlink(nomFic);

  L_REPCOURANT(repertoire);
  chdir(repertoire);

  /* modification de la liste des blasons des enfants */

  enf=0;
  TANTQUE enf<L_NBELEVES() FAIRE
    i=1;
    nbBrevetsElev=L_NBBREVETSELEV(enf);
    TANTQUE i<=nbBrevetsElev FAIRE
       SI abs(L_BREVELEV(enf,i))==abs(idBrevetRef) ALORS
	  /* Decalage du tableau  partir du brevet trouve */
	  TANTQUE i<nbBrevetsElev FAIRE
	     E_BREVELEV(enf,i,L_BREVELEV(enf,i+1));
	     i++;
	  FIN_TANTQUE
	  E_NBBREVETSELEV(enf,nbBrevetsElev-1);
       FIN_SI
       i++;
    FIN_TANTQUE

    /* mise  jour du tableau des indices de brevets */
    i=1;
    TANTQUE i<=L_NBBREVETSELEV(enf) FAIRE
       SI abs(L_BREVELEV(enf,i))>abs(idBrevetRef) ALORS
	  SI L_BREVELEV(enf,i)>0 ALORS
	     E_BREVELEV(enf,i,L_BREVELEV(enf,i)-1);
	  SINON
	     E_BREVELEV(enf,i,L_BREVELEV(enf,i)+1);
	  FIN_SI
       FIN_SI
       i++;
    FIN_TANTQUE

    enf++;
  FIN_TANTQUE

  SI affFen==VRAI ALORS
     Message(7,ATTRTITLE,NON_INIT,"\n  Suppression du brevet - %s - \n",nomBrevet);
  FIN_SI

  /* modification des indices des brevets */
  i=idBrevetRef;
  TANTQUE i<L_NBBREVETS() FAIRE
     memcpy(&(TabBrevets[i]),
	    &(TabBrevets[i+1]),sizeof(T_BREVET));
     i++;
  FIN_TANTQUE

  E_NBBREVETS(L_NBBREVETS()-1);

  /* Sauvegarde des fichiers */
  EnregFicBrevets();

  enf=0;
  TANTQUE enf<L_NBELEVES() FAIRE
     EnregFicEnf(enf);

     /* mise  jour des PTs */
     LectureDuPT(enf,NON_INIT);
     i=0;
     TANTQUE PT[i]!=NON_INIT ET i<NB_MAX_ITEM_PT FAIRE
       SI PT[i]>0 ET PT[i]>idBrevetRef ALORS
	  PT[i]=PT[i]-1;
       FIN_SI
       SI PT[i]<0 ET PT[i]<idBrevetRef ALORS
	  PT[i]=PT[i]+1;
       FIN_SI
       SI abs(PT[i])==idBrevetRef ALORS
	  PT[i]=NON_INIT;
       FIN_SI

       i++;
     FIN_TANTQUE
     EnregFicPTEnf(enf);
     enf++;
  FIN_TANTQUE

  EnregFicEleves(-1);

  /* Relecture des fichiers */

  InitBrevets();
  InitEleves();
fin

/* ----------------------------------------------------------------- */


PROCEDURE ModifierBrevet(int clef,int emetteur)
/* clef%10 => MODIFIER ou AJOUTER
   clef/10 => numero de brevet ventuel */

debut
  windows *W_modifBrev;
  char nomGet[LG_TITRE_BREVET+1];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+1];
  char nom[LG_LIGNE+1];
  int idBrevet, id=1,categorie, cr,i,auteur;
  CHOICE *listeCat;
  CHOICE *listeAuteur;

/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

    SI (clef%10)==MODIFIER ALORS
       id=1;
       idBrevet=clef/10;
       SI idBrevet<=0 ALORS
	  retour;
       FIN_SI

       memset(comment1,' ',LG_COMMENT);
       memset(comment2,' ',LG_COMMENT);
       comment1[LG_COMMENT]='\0';comment2[LG_COMMENT]='\0';
       LitInfosBrevet(idBrevet,nom,comment1,comment2);
       auteur=L_IDAUTEUR(idBrevet);

       i=strlen(nom);
       TANTQUE i<LG_TITRE_BREVET FAIRE
	  nom[i]=' ';
	  i++;
       FIN_TANTQUE
       nom[i]='\0';

       i=strlen(comment1);
       TANTQUE i<LG_COMMENT FAIRE
	  comment1[i]=' ';
	  i++;
       FIN_TANTQUE
       comment1[i]='\0';

       i=strlen(comment2);
       TANTQUE i<LG_COMMENT FAIRE
	  comment2[i]=' ';
	  i++;
       FIN_TANTQUE
       comment2[i]='\0';

       /*DetenteursBrevet(idBrevet);*/
       W_modifBrev=_wincreate(2,3,77,21,
			  SIMPLE,ATTRNORMAL,ATTRBORDER,"Modification d'un brevet/projet",ATTRTITLE);
    SINON
       W_modifBrev=_wincreate(2,3,77,21,
			  SIMPLE,ATTRNORMAL,ATTRBORDER,"Cration d'un projet",ATTRTITLE);
       memset(nom,' ',LG_TITRE_BREVET);
       nom[LG_TITRE_BREVET]='\0';

       idBrevet=L_NBBREVETS()+1;

       memset(comment1,' ',LG_COMMENT);
       comment1[LG_COMMENT]='\0';
       memset(comment2,' ',LG_COMMENT);
       comment2[LG_COMMENT]='\0';
/*       LitInfosBrevet(idBrevet,nom,comment1,comment2);*/

       /* Par dfaut, pas de niveau */
       /* Par dfaut, le brevet n'a pas de catgorie */
       E_IDCATEGORIE(idBrevet,AUCUNE_CATEGORIE);

       SI emetteur>=0 ALORS
	  auteur=emetteur;
	  E_IDAUTEUR(idBrevet,auteur);
       SINON
	  /* cas impossible */
	  auteur=AUCUN_AUTEUR;
       FIN_SI
    FIN_SI

    _winselect(W_modifBrev);
    _winclrscr();

    SI L_NBDETENTEURS(idBrevet) > 0 ALORS
       _wingotoxy(6,1);
       _winprintf("!! %d dtenteur(s) du brevet !!",L_NBDETENTEURS(idBrevet));
    FIN_SI

    /***************** nom du brevet **********************/
    _wingotoxy(45,1);_winputs("Appuie sur la touche Entre");

    _wingotoxy(2,3);_winputs("Titre : \n");
    memset(nomGet,' ',LG_TITRE_BREVET);
    nomGet[LG_TITRE_BREVET]='\0';
    strncpy(nomGet,nom,strlen(nomGet));

    _getadd(2+8,3,STRING,nomGet,0,"Titre du brevet");

    cr=_getread(NORMAL_MODE);
    COPIER(nomGet,SuppEspaceFin(nomGet));
    _getdispose();

    SI nomGet[0]=='\0' OU cr==CF4 ALORS
       _getdispose();
       _windispose(W_modifBrev);
       retour;
    FIN_SI

    /****************** auteur *****************************************/

       _wingotoxy(2,5);_winputs("Auteur : ");
       SI L_IDAUTEUR(idBrevet)!=AUCUN_AUTEUR ALORS
	  _winputs(L_SURNOMELEVE(L_IDAUTEUR(idBrevet)));
       SINON
	  _winputs("Aucun");
       FIN_SI

       SI emetteur==ACCES_INSTIT ALORS
	  id=0;
	  listeAuteur=_choiceadd(" Aucun ");
	  TANTQUE id<L_NBELEVES() FAIRE
	     _choiceadd(L_SURNOMELEVE(id));
	     id++;
	  FIN_TANTQUE

	  _choiceend();

	  id=_choiceread(2,7,LG_SURNOM_ELEVE+5,5,0,listeAuteur);
	  _choicedispose(listeAuteur);

	  SI id==-1 ALORS
	     _getdispose();
	     _windispose(W_modifBrev);
	     retour;
	  FIN_SI

	  _wingotoxy(2+9,5);_winclreol();_wingotoxy(2+9,5);
	  SI id>0 ALORS
	     auteur=id-1;
	     E_IDAUTEUR(idBrevet,auteur);
	     _winprintf("%s",L_SURNOMELEVE(auteur));
	  SINON
	     SI id==0 ALORS
		auteur=AUCUN_AUTEUR;
		E_IDAUTEUR(idBrevet,AUCUN_AUTEUR);
		_winputs("AUCUN");
	     FIN_SI
	  FIN_SI
       FIN_SI

    /****************** categorie *****************************************/

    SI L_NBCATEGORIE()>0 /*ET (clef%10)!=MODIFIER*/ ALORS
       _wingotoxy(40,5);_winputs("Catgorie : ");
       SI L_IDCATEGORIE(idBrevet)>=0 ALORS
	  categorie=L_IDCATEGORIE(idBrevet);
	  _winputs(Categorie[categorie].Libelle);
       SINON
	  categorie=-1;
	  _winputs("Aucune");
       FIN_SI
       id=0;
       listeCat=_choiceadd(" Aucune ");
       TANTQUE id<L_NBCATEGORIE() FAIRE
	  _choiceadd(Categorie[id].Libelle);
	  id++;
       FIN_TANTQUE

       _choiceend();

       id=_choiceread(40,7,LG_CATEGORIE+5,5,0,listeCat);
       _choicedispose(listeCat);

       SI id==-1 ALORS
	  _getdispose();
	  _windispose(W_modifBrev);
	  retour;
       FIN_SI

       _wingotoxy(40+12,5);_winclreol();_wingotoxy(40+12,5);
       SI id>0 ALORS
	  categorie=id-1;
	  E_IDCATEGORIE(idBrevet,categorie);
	  _winprintf("%s",Categorie[categorie].Libelle);
       SINON
	  SI id==0 ALORS
	     E_IDCATEGORIE(idBrevet,AUCUNE_CATEGORIE);
	     _winputs("AUCUNE");
	  FIN_SI
       FIN_SI
    SINON
       categorie=L_IDCATEGORIE(idBrevet);
    FIN_SI

    /****************** choix des commentaires **************************/

    SI cr!=CF4 ALORS
       comment1[LG_COMMENT]='\0';comment2[LG_COMMENT]='\0';
       _wingotoxy(25,13);_winputs("Informations\n");
       _getadd(2,15,STRING,comment1,0,"Autres informations");
       _getadd(2,17,STRING,comment2,0,"Autres informations");
       cr=_getread(NORMAL_MODE);
       _getdispose();

       /* traitement des modifications */
       SI (clef%10)==NOUVEAU ALORS
	  E_NBBREVETS(idBrevet);
       FIN_SI
       _getdispose();
       _windispose(W_modifBrev);
       SI cr!=CF4 ALORS
	  ModifBrevetDansFicBrevet(idBrevet,categorie,auteur);
	  SauveInfosBrevet(idBrevet,nomGet,comment1,comment2);

	  SI (clef%10)==MODIFIER ALORS

	     Message(13,ATTRTITLE,NON_INIT,"Modification de brevet russie : \n\n- nom : %s\n- Auteur : %s\n- Catgorie : %s\n- Commentaires : \n%s\n%s",
	       nomGet,auteur>=0?L_SURNOMELEVE(auteur):"Aucun",categorie>=0?Categorie[categorie].Libelle:"Aucune",comment1,comment2);
	     ArchiveChangement(-1,idBrevet,emetteur,"BR M");
	  SINON
	     Message(13,ATTRTITLE,NON_INIT,"Cration de brevet russie : \n\n- nom : %s\n- Auteur : %s\n- Catgorie : %s\n- Commentaires : \n%s\n%s",
	       nomGet,auteur>=0?L_SURNOMELEVE(auteur):"Aucun",categorie>=0?Categorie[categorie].Libelle:"Aucune",comment1,comment2);
	     ArchiveChangement(-1,idBrevet,emetteur,"BR +");
	     SI emetteur>=0 ALORS
		EnvoiToutleMonde(idBrevet,emetteur);
	     FIN_SI

	  FIN_SI
       FIN_SI
    SINON
       _getdispose();
       _windispose(W_modifBrev);
       retour;
    FIN_SI

fin

/* ----------------------------------------------------------- */
PROCEDURE far Sauvegarde(int clef)
debut
  char msg[300];

  SI _mesdisplay("Cette opration peut prendre quelques minutes.\nVeux-tu continuer ?")==VRAI ALORS

     gotoxy(30,10);
     puts("Patience .... ");

     /* Sauvegarde des blasons */
     ListeBrevetsEnfant(NON_INIT);
     CreerBlasCat(NON_INIT);

     /* Sauvegarde des listes de brevets */
     ListesBrevets();


     COPIER(msg,"\nDans le dossier de Bingo :\n\n- ListeBrevetsOrdre : Brevets dans l'ordre de cration");
     strcat(msg,"\n- ListeBrevetsAlpha : Brevets dans l'ordre alpha\n- ListeBrevetsCat: Brevets par catgorie\n- ListeBlasons : Blasons\n- ListeBlasonsCat : Blasons par catgorie");

     Message(13,ATTRMESSAGE,NON_INIT,msg);

  FIN_SI
fin


/********************************************************************/

PROCEDURE far GestEvts(int clef)
debut
  int ancPosX,ancPosY,posX=0,posY=0,etatBouton=0,x=0,y=0,xTrouve=0,yTrouve=0;
  int idEnfant, xFin, yFin, couleur;
  int c=0;    /* caractere */
  char nomBarre[100];
  int idBrevet=PAS_DE_BREVET;
  char far *barreFonc=NULL;
  int ReAffich=VRAI;
  windows *fenetre;
  int sortie=FAUX;
  unsigned int cpt=0,cpt2=0;
  char find[LG_RECHERCHE+1];
  int arbreClasse=VRAI;
  int trouve;
  int idBrevF1=-1,memoIdEnfant;

/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/

  LORSQUE clef VAUT
     SOIT GEST_TOUS   : idEnfant=0;
			arbreClasse=FAUX;
			FIN_SOIT
     SOIT GEST_TOUS_ARBRE : idEnfant=0;
			    arbreClasse=VRAI;
			    FIN_SOIT
     SOIT GEST_ARBRE :
			SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
			   idEnfant=L_TYPEACCES();
			SINON
			  idEnfant=-1;
			FIN_SI
			FIN_SOIT
     AUTRE           :  idEnfant=clef;
			FIN_SOIT
  FIN_LORSQUE

  SI idEnfant>=0 ALORS
     AttrFenPrinc=ATTRBLASON;
  SINON
     AttrFenPrinc=ATTRARBRE;
  FIN_SI
  fenetre=_wincreate(1,2,80,25,SIMPLE,AttrFenPrinc,AttrFenPrinc,
		    "",ATTRTITLE);
  _winselect(fenetre);

  InitBrevets();
  InitEleves();
  LectureConfig();

  memset(find,' ',LG_RECHERCHE);
  find[LG_RECHERCHE]='\0';

  COPIER(nomBarre,"");
  barreFonc=_helpbarcreate(nomBarre);
  posX=(X_AXETRONC-2)*8;posY=(Y_AXETRONC+1)*8;
  AllumeCurseurSouris();
  PositionnementCurseur(posX,posY+8);

  REPETER
    SI ReAffich==VRAI ALORS
       idBrevF1=-1;

       EteintCurseurSouris();
       _helpbardispose(barreFonc);
       _windispose(fenetre);

       SI idEnfant!=-1 ALORS
	  AttrFenPrinc=ATTRBLASON;
       SINON
	  AttrFenPrinc=ATTRARBRE;
       FIN_SI
       fenetre=_wincreate(1,2,80,25,SIMPLE,AttrFenPrinc,AttrFenPrinc,
		    "",ATTRTITLE);
       _winselect(fenetre);
       InitAffichage();
       InitBrevets();
       InitEleves();
       LectureDesPTs();
       AffichGraphisme(idEnfant,arbreClasse);

       COPIER(nomBarre,"");
       SI idEnfant!=-1 ALORS
	  SI L_TYPEACCES()==ACCES_INSTIT ALORS
	     sprintf(nomBarre,"%s(%d) F1:Aide  ** Ctrl-F11:Quitter(responsable)",L_SURNOMELEVE(idEnfant),L_NBBREVETSELEV(idEnfant));
	  SINON
	     sprintf(nomBarre,"%s(%d) F1:Aide  F5:Ecrire  F8:Demander une aide",L_SURNOMELEVE(idEnfant),L_NBBREVETSELEV(idEnfant));
	  FIN_SI
       SINON
	  SI L_TYPEACCES()==ACCES_INSTIT ALORS
	     sprintf(nomBarre," ARBRE(%d) F1:Aide ** Ctrl-F11:Quitter(responsable) **",L_NBREUSSITES());
	  SINON
	     sprintf(nomBarre," ARBRE(%d) F1:Aide   F2:Chercher   F11:Connexion   F10:Menu",L_NBREUSSITES());
	  FIN_SI
       FIN_SI

       barreFonc=_helpbarcreate(nomBarre);
       _helpbarshow(barreFonc);

       /* positionnement du curseur sur le brevet */
       SI idBrevet!=PAS_DE_BREVET ALORS
	  y=0;
	  TANTQUE y<25 FAIRE
	     x=0;
	     TANTQUE x<80 FAIRE
		SI idBrevet==L_TABAFFICH(x,y)%1000 ALORS
		   posX=(x-1)*8;posY=(y-2)*8;
		   PositionnementCurseur(posX,posY+8);
		FIN_SI
		x++;
	     FIN_TANTQUE
	     y++;
	  FIN_TANTQUE
       FIN_SI

       AllumeCurseurSouris();

       ReAffich=FAUX;
    FIN_SI

    ancPosX=posX;ancPosY=posY;
    PositionEtatSouris(&etatBouton,&posX,&posY);
    SI posX!=ancPosX OU posY!=ancPosY ALORS
       x=(posX/8)+1;
       y=(posY/8)+1;
       idBrevet=L_TABAFFICH(x,y)%1000;
       AffichInfoBrevet(idBrevet,idEnfant);
/*       SI idBrevet!=PAS_DE_BREVET ALORS
	  _helpbardispose(barreFonc);
       FIN_SI */
    FIN_SI

    SI kbhit() ALORS
       c=_kbdread();
       y=2;
       cpt=0;
    SINON
       cpt=cpt++;
       SI cpt>=10000 ALORS
	  cpt=0;
	  cpt2++;
	  SI cpt2>=1000 ALORS
	     InitBrevets();
	     InitEleves();
	     ReAffich=VRAI;
	     cpt2=0;
	  FIN_SI
       FIN_SI
    FIN_SI

    LORSQUE c VAUT
      SOIT CF4 : c=0;
		 sortie=VRAI;
		 LanceMenu=FAUX;
		 FIN_SOIT
      SOIT F1  : c=0;
		 ReAffich=VRAI;
		 LORSQUE L_TYPEACCES() VAUT
		    SOIT ACCES_INSTIT :   SI idBrevet==PAS_DE_BREVET ALORS
					     _helpdisplay(5);
					  SINON
					     _helpdisplay(6);
					  FIN_SI
					  FIN_SOIT
		    SOIT ACCES_NON_INIT : SI idBrevet==PAS_DE_BREVET ALORS
					      _helpdisplay(1);
					  SINON
					      _helpdisplay(2);
					  FIN_SI
					  FIN_SOIT
		    AUTRE              :  SI idBrevet==PAS_DE_BREVET ALORS
					     _helpdisplay(3);
					  SINON
					     _helpdisplay(4);
					  FIN_SI
					  FIN_SOIT
		 FIN_LORSQUE
		 FIN_SOIT
      SOIT ESC : c=0;
		 SI L_TYPEACCES()!=ACCES_NON_INIT ET
		    L_TYPEACCES()!=ACCES_INSTIT ALORS
		    /*AuRevoir();*/
		    idEnfant=-1;
		    clef=GEST_ARBRE;
		    SI L_TYPEACCES()!=ACCES_INSTIT ALORS
		       E_TYPEACCES(ACCES_NON_INIT);
		    FIN_SI
		    ReAffich=VRAI;
		 FIN_SI
		 FIN_SOIT;

      SOIT DOWN : c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX,posY+8);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y)%1000;
		  FIN_SOIT
      SOIT UP   : c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX,posY-8);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y)%1000;
		  FIN_SOIT
      SOIT RIGHT: c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX+8,posY);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y)%1000;
		  FIN_SOIT
      SOIT LEFT : c=0;
		  EteintCurseurSouris();
		  PositionnementCurseur(posX-8,posY);
		  AllumeCurseurSouris();
		  idBrevet=L_TABAFFICH(x,y)%1000;
		  FIN_SOIT

      SOIT F2 : /*SI premierPassage==VRAI ALORS
		   ReAffich=VRAI;
		   premierPassage=FAUX;
		SINON
		   premierPassage=VRAI;*/
		   c=0;
		   SI SaisieMotCle(find)==VRAI ALORS

		      xFin=0;yFin=0;
		      xTrouve=0;yTrouve=0;
		      EteintCurseurSouris();

		      SI RechercherBrevet(xFin,yFin,&xTrouve,&yTrouve,find)!=VRAI ALORS
			 Message(13,ATTRTITLE,NON_INIT,"\n\n\n Les caractres suivants n'ont t trouv \n\n dans AUCUN brevet : %s",find);
		      FIN_SI

		      trouve=VRAI;
		      TANTQUE trouve==VRAI FAIRE
			trouve=RechercherBrevet(xFin,yFin,&xTrouve,&yTrouve,find);
		      FIN_TANTQUE;

		      posX=(xTrouve-1)*8;posY=(yTrouve-2)*8;
		      PositionnementCurseur(posX,posY+8);
		      AllumeCurseurSouris();

		   FIN_SI

		   /* on rajoute des espaces  la fin de la chaine "fin" */
		   memset(find+strlen(find),' ',LG_RECHERCHE-strlen(find));
		   find[LG_RECHERCHE]='\0';

		/*FIN_SI*/
		FIN_SOIT



      SOIT F5 : c=0;
		EcrireA(0);
		ReAffich=VRAI;
		FIN_SOIT

      SOIT F6  : c=0;
		 EcrireA(1);
		 ReAffich=VRAI;
		 FIN_SOIT

      SOIT F7   :  /* affichage du blason */
		   c=0;
		   ReAffich=VRAI; memoIdEnfant=idEnfant;
		   SI L_TYPEACCES()==ACCES_INSTIT ALORS
		      SI idEnfant<0 ALORS
			 idEnfant=SelectEnfant(VRAI,NON_INIT,"QUI ?");
			 SI idEnfant<0 ALORS
			    ReAffich=FAUX;
			 FIN_SI
		      FIN_SI
		   SINON
		      SI idEnfant<0 ALORS
			 ReAffich=FAUX;
		      FIN_SI
		   FIN_SI
		   SI ReAffich==VRAI ALORS
		      ListeBrevetsEnfant(idEnfant);
		   FIN_SI
		   idEnfant=memoIdEnfant;
		   FIN_SOIT

      SOIT 'o'  :
      SOIT 'O'  :   c=0;
		   SI L_ORDRE()==ORDRE_CHRONO ALORS
		      E_ORDRE(ORDRE_DETENTEURS);
                   SINON
		      E_ORDRE(ORDRE_CHRONO);
		   FIN_SI
/*		   ReAffich=VRAI;*/
		   FIN_SOIT
       SOIT 'A':
       SOIT 'a':  SI L_TYPEACCES()>=0 ALORS
		     c=0;
		     ModifierBrevet(NOUVEAU,L_TYPEACCES());
		     ReAffich=VRAI;
		  FIN_SI
		  FIN_SOIT
       SOIT 'M' :
       SOIT 'm' :  c=0;
		   SI L_TYPEACCES()!=ACCES_NON_INIT ET idBrevet!=PAS_DE_BREVET ALORS
		      SI L_TYPEACCES()==ACCES_INSTIT OU L_IDAUTEUR(idBrevet)==L_TYPEACCES() ALORS
			 ModifierBrevet(MODIFIER+10*idBrevet,L_TYPEACCES());
			 ReAffich=VRAI;
		      FIN_SI
		   FIN_SI
		   FIN_SOIT;
       SOIT 'R' :
       SOIT 'r' : c=0;
		   SI L_TYPEACCES()!=ACCES_NON_INIT ET idBrevet!=PAS_DE_BREVET ALORS
		      RangerBrevet(idBrevet);
		   FIN_SI
		   ReAffich=VRAI;
		   FIN_SOIT;
/*       SOIT 'I' :
       SOIT 'i' :  c=0;
		   GroupesDeTravail(VRAI);
		   FIN_SOIT;*/

       SOIT F8  :  c=0;
		   SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ET idBrevet!=PAS_DE_BREVET ALORS
		      idEnfant=L_TYPEACCES();
		      EnvoiGroupe(idBrevet,idEnfant,VRAI);
		   FIN_SI
		   FIN_SOIT

       SOIT F9 :   c=0;
		   GroupesDeTravail();
		   FIN_SOIT;
       SOIT F10 :  c=0;
		   sortie=VRAI;
		   LanceMenu=VRAI;
		   AffichBandeau();
		   FIN_SOIT
       SOIT F11 :  c=0;
		   SI (L_TYPEACCES()==ACCES_INSTIT OU
		      L_TYPEACCES()==ACCES_NON_INIT) ET L_NBELEVES()>0 ALORS
		      idEnfant=SelectEnfant(VRAI,NON_INIT,"      Prnom");
		      SI idEnfant>=0 ALORS
			 SI L_TYPEACCES()!=ACCES_INSTIT ALORS
			    E_TYPEACCES(idEnfant);
			    VoirMaBoite(idEnfant);
			 FIN_SI
		      FIN_SI
		      ReAffich=VRAI;
		   FIN_SI
		   FIN_SOIT;
	SOIT ' ' : c=0;
		   SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
		      SI arbreClasse==VRAI ALORS
			 arbreClasse=FAUX;
		      SINON
			 arbreClasse=VRAI;
		      FIN_SI
		      ReAffich=VRAI;
		   FIN_SI
		   FIN_SOIT
	SOIT CF11 :  c=0;
		    SI L_TYPEACCES()!=ACCES_INSTIT ALORS
		       SI CodeInstit()==VRAI ALORS
			  Nouvelles(0);
		       FIN_SI
		    SINON
		       /*AuRevoir();*/
		       idEnfant=-1;
		       E_TYPEACCES(ACCES_NON_INIT);
		    FIN_SI
		    ReAffich=VRAI;
		    FIN_SOIT
       SOIT F12 :  c=0;
		   SI L_MODECAT()==MODE_CATEGORIE ALORS
		      E_MODECAT(MODE_SANS_CATEGORIE);
		   SINON
		      E_MODECAT(MODE_CATEGORIE);
		   FIN_SI
		   ReAffich=VRAI;
		   FIN_SOIT

       SOIT CR :   c=0;
		   SI idBrevet!=PAS_DE_BREVET ALORS
		      SI DetenteursBrevet(idBrevet)==VRAI ALORS
			 ReAffich=VRAI;
		      FIN_SI
		      c=0;
		   FIN_SI
		   FIN_SOIT
       SOIT SF1 :  AffichePalette();
		   c=0;
		   ReAffich=VRAI;
		   FIN_SOIT
       SOIT '<' :  c=0;
		   LargeurTronc--;
		   LargeurTronc=max(2,LargeurTronc);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT
       SOIT '>' :  c=0;
		   LargeurTronc++;
		   LargeurTronc=min(9,LargeurTronc);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT

       SOIT '+'  : c=0;
		   LongueurBranche=LongueurBranche++;
		   LongueurBranche=min(9,LongueurBranche);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT

       SOIT '-'  : c=0;
		   LongueurBranche=LongueurBranche--;
		   LongueurBranche=max(0,LongueurBranche);
		   ReAffich=VRAI;
		   EnregConfig();
		   FIN_SOIT

       SOIT 'F'  :
       SOIT 'f'  : c=0;
		   SI idBrevet!=PAS_DE_BREVET ET L_TYPEACCES()==ACCES_INSTIT ALORS
		      EteintCurseurSouris();
		      x=(posX/8)+1;
		      y=(posY/8)+1;

		      SI idBrevF1==idBrevet ALORS
			 /* On efface le 'F' */
			 idBrevF1=-1;
			 couleur=0;
/*			 AffichBrevet(x-1,y-2,NON_INIT,idBrevet,CouleurBrevet(couleur,idBrevet,NON_INIT,VRAI));*/
			 AffichBrevet(x-1,y-2,NON_INIT,idBrevet,VRAI, couleur);

		      SINON
			 SI idBrevF1==-1 ALORS
			    /* On affiche un 'F' */
			    idBrevF1=idBrevet;
			    AffichBrevet(x-1,y-2,NON_INIT,idBrevet,VRAI,COULEUR1);
			    _winattr((COULEUR2<<4)+COULEUR1+CLIGNOTE);
			    _wingotoxy(x-1,y-2);
			    _winputc('F');
			 SINON
			    /* on lance la fusion */
			    FusionneDeuxBrevets(idBrevF1,idBrevet);
			    SI idBrevF1<idBrevet ALORS
			       idBrevet--;
			    FIN_SI
			    idBrevF1=-1;
			    ReAffich=VRAI;

			 FIN_SI
		      FIN_SI
		      AllumeCurseurSouris();
		   FIN_SI
		   FIN_SOIT

       SOIT 'p'  :
       SOIT 'P'  : c=0;
		   SI L_TYPEACCES()!=ACCES_INSTIT ET L_TYPEACCES()!=ACCES_NON_INIT ALORS
		      ChangeMotDePasse(idEnfant);
		      ReAffich=VRAI;
		   FIN_SI
		   FIN_SOIT
       SOIT 's'  :
       SOIT 'S'  : c=0;
		   SI L_TYPEACCES()==ACCES_INSTIT ET idBrevet!=PAS_DE_BREVET ALORS
		      SupprimerBrevet(idBrevet,VRAI,L_TYPEACCES());
		      ReAffich=VRAI;
		   FIN_SI
		   FIN_SOIT



       SOIT PGDN  : SI clef==GEST_TOUS OU clef==GEST_TOUS_ARBRE ALORS
		       c=0;
		       idEnfant++;
		       SI idEnfant>=L_NBELEVES() ALORS
			  idEnfant=0;
		       FIN_SI
		       ReAffich=VRAI;
		    FIN_SI
		    FIN_SOIT
       SOIT PGUP  : SI clef==GEST_TOUS OU clef==GEST_TOUS_ARBRE ALORS
		       c=0;
		       idEnfant--;
		       SI idEnfant<0 ALORS
			  idEnfant=L_NBELEVES()-1;
		       FIN_SI
		       ReAffich=VRAI;
		    FIN_SI
		    FIN_SOIT

    FIN_LORSQUE

  JUSQUA sortie==VRAI FIN_REPETER;

  EteintCurseurSouris();

  _helpbardispose(barreFonc);
  _windispose(fenetre);

fin
