#include "bingo.h"

/*--------------------------------------------*/
PROCEDURE EnvoiToutleMonde(int idDemande, int idEnfant)
debut
  int destinataire;
  char mess[LG_SURNOM_ELEVE*NB_MAX_ELEVES+35];
  char ligne1[LG_LIGNE+1], ligne2[LG_LIGNE+1];
  int archivage=VRAI;
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet[LG_TITRE_BREVET+1];

  nomBrevet[0]='\0';
  comment1[0]='\0';
  comment2[0]='\0';
  LitInfosBrevet(idDemande,nomBrevet,comment1,comment2);

  destinataire=0;
  TANTQUE destinataire<L_NBELEVES() FAIRE
     SI destinataire!=idEnfant ALORS
	sprintf(ligne1,"%s a cr un nouveau projet :", L_SURNOMELEVE(idEnfant));
	sprintf(ligne2,"Brevet/Projet : < %s >",nomBrevet);
	EnvoyerMessage(-2,destinataire,ligne1,ligne2,archivage);
	SI archivage==VRAI ALORS
	   archivage=FAUX;
	FIN_SI
     FIN_SI
     destinataire++;
  FIN_TANTQUE

  sprintf(mess,"Un message a t envoy  tout le monde pour signaler ce nouveau projet !");
  Message(13,ATTRTITLE,NON_INIT,mess);
fin

/*--------------------------------------------*/
PROCEDURE EnvoiGroupe(int idDemande, int idEnfant, int aide)
/*    aide = VRAI => une demande d'aide est envoye aux dtenteurs du brevet
/*    aide = FAUX => une information est envoye aux dtenteurs,  ceux qui ont le mme projet et  l'auteur*/
debut
  int destinataire;
  int nbDestinataires;
  char mess[LG_SURNOM_ELEVE*NB_MAX_ELEVES+35];
  char ligne1[LG_LIGNE+1], ligne2[LG_LIGNE+1];
  int archivage=VRAI;
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+2];
  char nomBrevet[LG_TITRE_BREVET+1];

  nomBrevet[0]='\0';
  comment1[0]='\0';
  comment2[0]='\0';
  LitInfosBrevet(idDemande,nomBrevet,comment1,comment2);

  /* Envoie d'un message aux dtenteurs=destinataires */
  destinataire=0;nbDestinataires=0;
  SI aide==VRAI ALORS
     sprintf(mess,"Une demande d'aide a t envoye  ");
  SINON
     sprintf(mess,"Un message a t envoy  ");
  FIN_SI
  TANTQUE destinataire<L_NBELEVES() FAIRE
     SI destinataire!=idEnfant ET
	(
	EnfantABrevet(destinataire,idDemande)==VRAI OU
	(aide==FAUX ET (LectureDuPT(destinataire,idDemande)==VRAI OU destinataire==L_IDAUTEUR(idDemande)))
	)
	 ALORS
	SI aide==VRAI ALORS
	   sprintf(ligne1,"%s a demand une aide sur :", L_SURNOMELEVE(idEnfant));
	SINON
	   sprintf(ligne1,"%s se lance dans le projet :", L_SURNOMELEVE(idEnfant));
	FIN_SI
	sprintf(ligne2,"Brevet/Projet : < %s >",nomBrevet);
	EnvoyerMessage(-2,destinataire,ligne1,ligne2,archivage);
	SI archivage==VRAI ALORS
	   archivage=FAUX;
	FIN_SI
	nbDestinataires++;

	strcat(mess,L_SURNOMELEVE(destinataire));
	strcat(mess,", ");
     FIN_SI
     destinataire++;
  FIN_TANTQUE

  SI nbDestinataires>0 ALORS
     SI aide==FAUX ALORS
	SI nbDestinataires==1 ALORS
	   strcat(mess,"pour l'informer de ton projet.");
	SINON
	   strcat(mess,"pour les informer de ton projet.");
	FIN_SI
     FIN_SI
     Message(13,ATTRTITLE,NON_INIT,mess);
  SINON
     Message(13,ATTRTITLE,NON_INIT,"\n\n   Personne n'a ce brevet pour l'instant");
  FIN_SI
fin

/* -------------------------------------------------------- */
PROCEDURE EnvoyerMessage(int expediteur, int destinataire, char *ligne1, char *ligne2,int archivage)
/* SI expediteur=-1 alors c'est l'instit */
/* SI expediteur=-2 alors c'est Bingo ! */
/* SI destinataire=NON_INIT alors c'est l'instit */
debut
  int cr;
  char repertoire[LG_PATH+1];
  char nomFic[LG_FIC_EXT+1];
  char chDate[30];
  FILE *ptFic;
  FILE *ptArch;

  L_REPDONNEES(repertoire);
  chdir(repertoire);

  SI (cr=chdir("msg"))!=0 ALORS
     mkdir("msg");
     cr=chdir("msg");
  FIN_SI
  SI cr!=0 ALORS
     SyntaxeErreur(ID_SEFE,"Pb dossier msg",0);
     retour;
  FIN_SI

  AffichDate(chDate);
  SI destinataire!=NON_INIT ALORS
     COPIER(nomFic,L_NOMFIC(destinataire));
     nomFic[strlen(nomFic)-4]='\0'; /* on supprime l'extension .txt */
  SINON
     COPIER(nomFic,L_FIC_INSTIT());
  FIN_SI
  strcat(nomFic,".txt");
  SI (ptFic=fopen(nomFic,"at"))==NULL ALORS
     ptFic=fopen(nomFic,"wt");
  FIN_SI
  SI ptFic==NULL OU cr!=0 ALORS
     L_REPCOURANT(repertoire);
     chdir(repertoire);

     SyntaxeErreur(ID_SEFE,nomFic,0);
     retour;
  FIN_SI

  /* archives */
  SI archivage==VRAI ALORS
     SI (ptArch=fopen(FIC_ARCHIVEMSG,"at"))==NULL ALORS
	ptArch=fopen(FIC_ARCHIVEMSG,"wt");
     FIN_SI
  FIN_SI


  LORSQUE expediteur VAUT
    SOIT -1 : /* expediteur = INSTIT */
	      fprintf(ptFic,"Le %s, le responsable a crit : \n%s\n%s\n\n",chDate,ligne1,ligne2);
	      Message(13,ATTRTITLE,NON_INIT,"\n\n\n\n            Ton message a t envoy !");
	      FIN_SOIT
    SOIT -2 : /* expediteur = BINGO */
	      fprintf(ptFic,"Le %s, %s\n%s\n\n",chDate,ligne1,ligne2);
	      SI archivage==VRAI ALORS
		 fprintf(ptArch,"Le %s, %s\n%s\n",chDate,ligne1,ligne2);
	      FIN_SI
	      FIN_SOIT
    AUTRE   : fprintf(ptFic,"Le %s, %s a crit : \n%s\n%s\n\n",chDate,L_SURNOMELEVE(L_TYPEACCES()),ligne1,ligne2);
	      Message(13,ATTRTITLE,L_TYPEACCES(),"\n\n\n\n           Ton message a t envoy !");

	      SI archivage==VRAI ALORS
		 SI destinataire!=NON_INIT ALORS
		    fprintf(ptArch,"Le %s, %s a crit  %s : \n%s\n%s\n",chDate,L_SURNOMELEVE(L_TYPEACCES()),
		    L_SURNOMELEVE(destinataire),ligne1,ligne2);
		 SINON
		    /* crire  l'instit */
		    fprintf(ptArch,"Le %s, %s a crit au responsable : \n%s\n%s\n\n",chDate,L_SURNOMELEVE(L_TYPEACCES()),
		    ligne1,ligne2);
		 FIN_SI
	      FIN_SI
  FIN_LORSQUE

  fclose(ptFic);

  SI archivage==VRAI ALORS
     fclose(ptArch);
  FIN_SI


  L_REPCOURANT(repertoire);
  chdir(repertoire);
fin


/* -------------------------------------------------------- */

PROCEDURE EcrireA(int destinataire)
/* destinataire=0 => crire aux enfants */
/* destinataire=1 => crire  l'instit */

debut
  int idEnfant;
  windows *W_ecrire;
  char titre[80];
  char comment1[LG_LIGNE+1], comment2[LG_LIGNE+1];
  char chDate[30];
  int i, LigneVide, expediteur;

  AffichDate(chDate);

/*  SI TestBD(VRAI) == NOK ALORS
     retour;
  FIN_SI*/



  SI L_TYPEACCES()!=ACCES_NON_INIT ALORS

     SI L_TYPEACCES()!=ACCES_INSTIT ALORS
	expediteur=L_TYPEACCES();
     SINON
	expediteur=-1;
     FIN_SI

     SI destinataire==0 ALORS
	idEnfant=SelectEnfant(FAUX,NON_INIT,"A qui ?");
	SI idEnfant<0 ALORS
	   retour;
	FIN_SI
	sprintf(titre,"Ecrire  %s %s",L_PRENOMELEVE(idEnfant),L_NOMELEVE(idEnfant));
     SINON
	sprintf(titre,"Ecrire au responsable");
	idEnfant=NON_INIT;
     FIN_SI

     W_ecrire=_wincreate(3,20,75,5,SIMPLE,ATTRNORMAL,ATTRBORDER,titre,ATTRTITLE);
     _winselect(W_ecrire);

     memset(comment1,' ',73);
     memset(comment2,' ',73);
     comment1[73]='\0';comment2[73]='\0';
     comment1[73]='\0';comment2[73]='\0';
     _getadd(2,2,STRING,comment1,0,"1re ligne");
     _getadd(2,3,STRING,comment2,0,"2me ligne");
     _getread(NORMAL_MODE);
     _getdispose();

     _windispose(W_ecrire);

     i=0;LigneVide=VRAI;
     TANTQUE LigneVide==VRAI ET i<70 ALORS
	SI comment1[i]!=' ' ALORS
	   LigneVide=FAUX;
	FIN_SI
	i++;
     FIN_TANTQUE

     SI LigneVide==FAUX ALORS
	EnvoyerMessage(expediteur,idEnfant, comment1, comment2,VRAI);
     FIN_SI

  SINON
     Message(13,ATTRTITLE,NON_INIT,"Je ne sais pas qui tu es !!");
  FIN_SI



fin